/***** Autogenerated from runtime.in; changes will be overwritten *****/

/*****
 * runtime.in
 * Tom Prince 2005/4/15
 *
 * Generate the runtime functions used by the vm::stack machine.
 *
 *****/

/* Autogenerated routines are specified like this (separated by a formfeed):
type asyname:cname(cparams)
{
  C code
}
*/


#include <cfloat>
#include "angle.h"
#include "pair.h"
#include "triple.h"
#include "transform.h"
#include "path.h"
#include "pen.h"
#include "guide.h"
#include "picture.h"
#include "drawpath.h"
#include "drawfill.h"
#include "drawclipbegin.h"
#include "drawclipend.h"
#include "drawlabel.h"
#include "drawverbatim.h"
#include "drawgsave.h"
#include "drawgrestore.h"
#include "drawlayer.h"
#include "drawimage.h"
#include "drawgroup.h"
#include "fileio.h"
#include "genv.h"
#include "builtin.h"
#include "texfile.h"
#include "pipestream.h"
#include "parser.h"
#include "stack.h"
#include "util.h"
#include "mathop.h"
#include "callable.h"
#include "stm.h"
  
#ifdef HAVE_LIBFFTW3
#include "fftw++.h"
#endif
  
using namespace vm;
using namespace camp;
using namespace settings;

namespace run {
using camp::pair;
using mem::string;
using vm::array;
using vm::frame;
using vm::stack;
using camp::transform;
using absyntax::runnable;

callable *atExitFunction=NULL;
callable *atDrawFunction=NULL;
  
typedef array boolarray;
typedef array intarray;
typedef array realarray;
typedef array realarray2;
typedef array pairarray;
typedef array triplearray;
typedef array patharray;
typedef array guidearray;
typedef array transformarray;
typedef array penarray;
typedef array penarray2;
typedef array stringarray;
typedef array stringarray2;
}

using vm::array;
using types::function;
using types::primVoid;
using types::primBoolean;
using types::primInt;
using types::primReal;
using types::primPair;
using types::primTriple;
using types::primPen;
using types::primPath;
using types::primGuide;
using types::primPicture;
using types::primString;
using types::primCode;
using types::primFile;
using types::primTransform;
using types::boolArray;
using types::intArray;
using types::realArray;
using types::realArray2;
using types::pairArray;
using types::tripleArray;
using types::pathArray;
using types::guideArray;
using types::transformArray;
using types::penArray;
using types::penArray2;
using types::stringArray;
using types::stringArray2;
using types::formal;

namespace loop {
  void doIRunnable(absyntax::runnable *r, bool embedded=false);
  void doITree(absyntax::block *tree, bool embedded=false);
}
  
function *voidFunction()
{
  return new function(primVoid());
}

const int camp::ColorComponents[]={0,0,1,3,4,0};

namespace vm {
const char *arraymismatch="operation attempted on arrays of different lengths";
}

namespace run {
  
const char *arraymin="cannot take min of empty array";
const char *arraymax="cannot take max of empty array";

static inline int Round(double x) 
{
  return int(x+((x >= 0) ? 0.5 : -0.5));
}

inline int sgn(double x) 
{
  return (x > 0.0 ? 1 : (x < 0.0 ? -1 : 0));
}

inline void CheckReallocate(double *& A, size_t n, size_t& old)
{
  if(n > old) {delete A; A=new double[n]; old=n;}
}

inline void CheckReallocate(double *& A, double *& B, size_t n, size_t& old)
{
  if(n > old) {delete A; A=new double[n]; delete B; B=new double[n]; old=n;}
}

void outOfBounds(const char *op, size_t len, int n)
{
  ostringstream buf;
  buf << op << " array of length " << len << " with out-of-bounds index "
      << n;
  error(buf.str().c_str());
}

item& arrayRead(array *a, int n)  
{
  size_t len=checkArray(a);
  bool cyclic=a->cyclic();
  if(cyclic && len > 0) n=imod(n,len);
  else if(n < 0 || n >= (int) len) outOfBounds("reading",len,n);
  return (*a)[(unsigned) n];
}

// Helper function to create deep arrays.
static array* deepArray(int depth, int *dims)
{
  assert(depth > 0);
  
  if (depth == 1) {
    return new array(dims[0]);
  } else {
    int length = dims[0];
    depth--; dims++;

    array *a = new array(length);

    for (int index = 0; index < length; index++) {
      (*a)[index] = deepArray(depth, dims);
    }
    return a;
  }
}
  
array *copyArray(array *a)
{
  size_t size=checkArray(a);
  array *c=new array(size);
  for(size_t i=0; i < size; i++) 
    (*c)[i]=(*a)[i];
  return c;
}

array *copyArray2(array *a)
{
  size_t size=checkArray(a);
  array *c=new array(size);
  for(size_t i=0; i < size; i++) {
    array *ai=read<array*>(a,i);
    size_t aisize=checkArray(ai);
    array *ci=new array(aisize);
    (*c)[i]=ci;
    for(size_t j=0; j < aisize; j++) 
      (*ci)[j]=(*ai)[j];
  }
  return c;
}

void writestring(stack *s)
{
  callable *suffix=pop<callable *>(s,NULL);
  string S=pop<string>(s);
  vm::item it=pop(s);
  bool defaultfile=isdefault(it);
  camp::file *f=defaultfile ? &camp::Stdout : vm::get<camp::file*>(it);
  if(!f->isOpen()) return;
  if(S != "") f->write(S);
  if(f->text()) {
    if(suffix) {
      s->push(f);
      suffix->call(s);
    } else if(defaultfile) f->writeline();
  }
}

void dividebyzero(size_t i)
{
  std::ostringstream buf;
  if(i > 0) buf << "array element " << i << ": ";
  buf << "Divide by zero";
  error(buf.str().c_str());
}
  
void integeroverflow(size_t i)
{
  std::ostringstream buf;
  if(i > 0) buf << "array element " << i << ": ";
  buf << "Integer overflow";
  error(buf.str().c_str());
}
  
void cleanup()
{
  defaultpen=camp::pen::startupdefaultpen();
  if(!interact::interactive) settings::scrollLines=0;
  
  if(TeXinitialized) {
    camp::TeXpipepreamble.clear();
    camp::TeXpreamble.clear();
    camp::tex.pipeclose();
    TeXinitialized=false;
  }
}

void exitFunction(stack *Stack)
{
  if(atExitFunction && !nullfunc::instance()->compare(atExitFunction)) {
    atExitFunction->call(Stack);
    atExitFunction=NULL;
  }
  cleanup();
}

void updateFunction(stack *Stack)
{
  if(atExitFunction && !nullfunc::instance()->compare(atExitFunction))
    atExitFunction->call(Stack);
}

default_t def;
string emptystring;
string commentchar="#";

}



namespace run {

// Initializers
void intZero(stack *Stack)
{

  {Stack->push<int>(0); return;}
}

void realZero(stack *Stack)
{

  {Stack->push<double>(0.0); return;}
}

void boolFalse(stack *Stack)
{

  {Stack->push<bool>(false); return;}
}

void pushNullArray(stack *Stack)
{

  {Stack->push<array*>(0); return;}
}

void pushNullRecord(stack *Stack)
{

  {Stack->push<frame*>(0); return;}
}

void pushNullFunction(stack *Stack)
{

  {Stack->push(nullfunc::instance()); return;}
}


// Default operations

// Put the default value token on the stack (in place of an argument when
// making a function call).
void pushDefault(stack *Stack)
{

  {Stack->push(def); return;}
}


// Test if the value on the stack is the default value token.
void isDefault(stack *Stack)
{
  item i = vm::pop(Stack);

  {Stack->push<bool>(isdefault(i)); return;}
}


// Logical operations
// bool !(bool b);
void gen8(stack *Stack)
{
  bool b = vm::pop<bool>(Stack);

  {Stack->push<bool>(!b); return;}
}

void boolMemEq(stack *Stack)
{
  frame * b = vm::pop<frame *>(Stack);
  frame * a = vm::pop<frame *>(Stack);

  {Stack->push<bool>(a == b); return;}
}

void boolMemNeq(stack *Stack)
{
  frame * b = vm::pop<frame *>(Stack);
  frame * a = vm::pop<frame *>(Stack);

  {Stack->push<bool>(a != b); return;}
}

void boolFuncEq(stack *Stack)
{
  callable * b = vm::pop<callable *>(Stack);
  callable * a = vm::pop<callable *>(Stack);

  {Stack->push<bool>(a->compare(b)); return;}
}

void boolFuncNeq(stack *Stack)
{
  callable * b = vm::pop<callable *>(Stack);
  callable * a = vm::pop<callable *>(Stack);

  {Stack->push<bool>(!(a->compare(b))); return;}
}


// Casts
void pairToGuide(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);

  {Stack->push<guide*>(new pairguide(z)); return;}
}

void pathToGuide(stack *Stack)
{
  path p = vm::pop<path>(Stack);

  {Stack->push<guide*>(new pathguide(p)); return;}
}

void guideToPath(stack *Stack)
{
  guide * g = vm::pop<guide *>(Stack);

  {Stack->push<path>(g->solve()); return;}
}


// Picture operations
void newPicture(stack *Stack)
{

  {Stack->push<picture*>(new picture()); return;}
}

// bool empty(picture *f);
void gen17(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);

  {Stack->push<bool>(f->null()); return;}
}

// pair max(picture *f);
void gen18(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);

  {Stack->push<pair>(f->bounds().Max()); return;}
}

// pair min(picture *f);
void gen19(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);

  {Stack->push<pair>(f->bounds().Min()); return;}
}

// void label(picture *f, string *s, string *size, double angle, pair position,	   pair align, pair scale, pen p);
void gen20(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  pair scale = vm::pop<pair>(Stack);
  pair align = vm::pop<pair>(Stack);
  pair position = vm::pop<pair>(Stack);
  double angle = vm::pop<double>(Stack);
  string * size = vm::pop<string *>(Stack);
  string * s = vm::pop<string *>(Stack);
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawLabel(*s,*size,angle,position,align,scale,p));
}

// bool labels(picture *f);
void gen21(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);

  {Stack->push<bool>(f->havelabels()); return;}
}

// void fill(picture *f, patharray *g, pen p);
void gen22(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawFill(copyArray(g),p));
}

// void latticeshade(picture *f, patharray *g, pen fillrule, penarray2 *p);
void gen23(stack *Stack)
{
  penarray2 * p = vm::pop<penarray2 *>(Stack);
  pen fillrule = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawLatticeShade(copyArray(g),fillrule,copyArray(p)));
}

// void axialshade(picture *f, patharray *g, pen pena, pair a, pen penb, pair b);
void gen24(stack *Stack)
{
  pair b = vm::pop<pair>(Stack);
  pen penb = vm::pop<pen>(Stack);
  pair a = vm::pop<pair>(Stack);
  pen pena = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawAxialShade(copyArray(g),pena,a,penb,b));
}

// void radialshade(picture *f, patharray *g, pen pena, pair a, double ra,		 pen penb, pair b, double rb);
void gen25(stack *Stack)
{
  double rb = vm::pop<double>(Stack);
  pair b = vm::pop<pair>(Stack);
  pen penb = vm::pop<pen>(Stack);
  double ra = vm::pop<double>(Stack);
  pair a = vm::pop<pair>(Stack);
  pen pena = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawRadialShade(copyArray(g),pena,a,ra,penb,b,rb));
}

// void gouraudshade(picture *f, patharray *g, pen fillrule, penarray *p,		  pairarray *z, intarray *edges);
void gen26(stack *Stack)
{
  intarray * edges = vm::pop<intarray *>(Stack);
  pairarray * z = vm::pop<pairarray *>(Stack);
  penarray * p = vm::pop<penarray *>(Stack);
  pen fillrule = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);

  checkArrays(p,z);
  checkArrays(z,edges);
  f->append(new drawGouraudShade(copyArray(g),fillrule,copyArray(p),
				 copyArray(z),copyArray(edges)));
}

// Clip a picture to a superpath using the given fill rule.
// Subsequent additions to the picture will not be affected by the clipping.
// void clip(picture *f, patharray *g, pen p);
void gen27(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);

  f->enclose(new drawClipBegin(copyArray(g),p),new drawClipEnd());
}

// void beginclip(picture *f, patharray *g, pen p);
void gen28(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawClipBegin(copyArray(g),p,false));
}

// void postscript(picture *f, string s);
void gen29(stack *Stack)
{
  string s = vm::pop<string>(Stack);
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawVerbatim(PostScript,s));
}

// void tex(picture *f, string s);
void gen30(stack *Stack)
{
  string s = vm::pop<string>(Stack);
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawVerbatim(TeX,s));
}

// void texpreamble(string s);
void gen31(stack *Stack)
{
  string s = vm::pop<string>(Stack);

  string t=s+"\n";
  camp::TeXpipepreamble.push_back(t);
  camp::TeXpreamble.push_back(t);
}

// void layer(picture *f);
void gen32(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawLayer());
}

// void image(picture *f, realarray2 *data, penarray *palette, 	   pair initial, pair final);
void gen33(stack *Stack)
{
  pair final = vm::pop<pair>(Stack);
  pair initial = vm::pop<pair>(Stack);
  penarray * palette = vm::pop<penarray *>(Stack);
  realarray2 * data = vm::pop<realarray2 *>(Stack);
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawImage(copyArray2(data),copyArray(palette),
			  matrix(initial,final)));
}

// void shipout(string prefix=emptystring, picture *f, picture *preamble=NULL,	     string format=emptystring, bool wait=0, bool quiet=0,	     transformarray *GUItransform, boolarray *GUIdelete);
void gen34(stack *Stack)
{
  boolarray * GUIdelete = vm::pop<boolarray *>(Stack);
  transformarray * GUItransform = vm::pop<transformarray *>(Stack);
  bool quiet = vm::pop<bool>(Stack,0);
  bool wait = vm::pop<bool>(Stack,0);
  string format = vm::pop<string>(Stack,emptystring);
  picture * preamble = vm::pop<picture *>(Stack,NULL);
  picture * f = vm::pop<picture *>(Stack);
  string prefix = vm::pop<string>(Stack,emptystring);

  if(prefix.empty()) prefix=getSetting<mem::string>("outname");
  
  size_t size=GUItransform && GUIdelete ?
    checkArrays(GUItransform,GUIdelete) : 0;
 
  if(getSetting<double>("deconstruct") || size) {
    picture *result=new picture;
    unsigned level=0;
    unsigned i=0;
    nodelist::iterator p;
    for(p = f->nodes.begin(); p != f->nodes.end(); ++p) {
      bool Delete;
      transform t;
      if(i < size) {
	t=*(read<transform*>(GUItransform,i));
	Delete=read<bool>(GUIdelete,i);
      } else {
	t=identity();
	Delete=false;
      }
      picture *group=new picture;
// Ignore unclosed begingroups but not spurious endgroups.
      const char *nobegin="endgroup without matching begingroup";
      assert(*p);
      if((*p)->endgroup()) error(nobegin);
      if((*p)->begingroup()) {
	++level;
	while(p != f->nodes.end() && level) {
	  drawElement *e=t.isIdentity() ? *p : (*p)->transformed(t);
	  group->append(e);
	  ++p;
	  if(p == f->nodes.end()) break;
	  assert(*p);
	  if((*p)->begingroup()) ++level;
	  if((*p)->endgroup()) if(level) --level;
	  else error(nobegin);
	}
      }
      if(p == f->nodes.end()) break;
      assert(*p);
      drawElement *e=t.isIdentity() ? *p : (*p)->transformed(t);
      group->append(e);
      if(!group->empty()) {
	if(getSetting<double>("deconstruct")) {
	  ostringstream buf;
	  buf << prefix << "_" << i;
	  group->shipout(preamble,buf.str(),"tgif",false,true,Delete);
	}
	++i;
      }
      if(size && !Delete) result->add(*group);
    }
    if(size) f=result;
  }

  f->shipout(preamble,prefix,format,wait,quiet);
}


// Pen operations
void newPen(stack *Stack)
{

  {Stack->push<pen>(pen()); return;}
}

// bool ==(pen a, pen b);
void gen36(stack *Stack)
{
  pen b = vm::pop<pen>(Stack);
  pen a = vm::pop<pen>(Stack);

  {Stack->push<bool>(a == b); return;}
}

// bool !=(pen a, pen b);
void gen37(stack *Stack)
{
  pen b = vm::pop<pen>(Stack);
  pen a = vm::pop<pen>(Stack);

  {Stack->push<bool>(a != b); return;}
}

// pen +(pen a, pen b);
void gen38(stack *Stack)
{
  pen b = vm::pop<pen>(Stack);
  pen a = vm::pop<pen>(Stack);

  {Stack->push<pen>(a+b); return;}
}

// pen *(double a, pen b);
void gen39(stack *Stack)
{
  pen b = vm::pop<pen>(Stack);
  double a = vm::pop<double>(Stack);

  {Stack->push<pen>(a*b); return;}
}

// pen *(pen a, double b);
void gen40(stack *Stack)
{
  double b = vm::pop<double>(Stack);
  pen a = vm::pop<pen>(Stack);

  {Stack->push<pen>(b*a); return;}
}

// pair max(pen p);
void gen41(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  {Stack->push<pair>(p.bounds().Max()); return;}
}

// pair min(pen p);
void gen42(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  {Stack->push<pair>(p.bounds().Min()); return;}
}

// Reset the meaning of pen default attributes.
// void resetdefaultpen();
void gen43(stack *)
{

  defaultpen=camp::pen::startupdefaultpen();
}

// void defaultpen(pen p);
void gen44(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  defaultpen=pen(resolvepen,p);
}

// pen defaultpen();
void gen45(stack *Stack)
{

  {Stack->push<pen>(defaultpen); return;}
}

// pen invisible();
void gen46(stack *Stack)
{

  {Stack->push<pen>(pen(invisiblepen)); return;}
}

// pen gray(pen p);
void gen47(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  if(p.rgb()) p.rgbtogrey();
  else if (p.cmyk()) p.cmyktogrey();
  {Stack->push<pen>(p); return;}
}

// pen rgb(pen p);
void gen48(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  if(p.grayscale()) p.greytorgb();
  else if (p.cmyk()) p.cmyktorgb();
  {Stack->push<pen>(p); return;}
}

// pen rgb(double r, double g, double b);
void gen49(stack *Stack)
{
  double b = vm::pop<double>(Stack);
  double g = vm::pop<double>(Stack);
  double r = vm::pop<double>(Stack);

  {Stack->push<pen>(pen(r,g,b)); return;}
}

// pen cmyk(double c, double m, double y, double k);
void gen50(stack *Stack)
{
  double k = vm::pop<double>(Stack);
  double y = vm::pop<double>(Stack);
  double m = vm::pop<double>(Stack);
  double c = vm::pop<double>(Stack);

  {Stack->push<pen>(pen(c,m,y,k)); return;}  
}

// pen gray(double gray);
void gen51(stack *Stack)
{
  double gray = vm::pop<double>(Stack);

  {Stack->push<pen>(pen(gray)); return;}
}

// realarray* colors(pen p);
void gen52(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  
  int n=ColorComponents[p.colorspace()];
  array *a=new array(n);
  
  switch(n) {
  case 0:
    break;
  case 1: 
    (*a)[0]=p.gray(); 
    break;
  case 3:
    (*a)[0]=p.red(); 
    (*a)[1]=p.green(); 
    (*a)[2]=p.blue(); 
    break;
  case 4:
    (*a)[0]=p.cyan();
    (*a)[1]=p.magenta(); 
    (*a)[2]=p.yellow(); 
    (*a)[3]=p.black();
    break;
  default:
    break;
  }
  {Stack->push<realarray*>(a); return;}
}

// pen pattern(string *s);
void gen53(stack *Stack)
{
  string * s = vm::pop<string *>(Stack);

  {Stack->push<pen>(pen(setpattern,*s)); return;}
}

// string pattern(pen p);
void gen54(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  {Stack->push<string>(p.fillpattern()); return;}  
}

// pen fillrule(int n);
void gen55(stack *Stack)
{
  int n = vm::pop<int>(Stack);

  {Stack->push<pen>(pen(n >= 0 && n < nFill ? (FillRule) n : DEFFILL)); return;}
}

// int fillrule(pen p);
void gen56(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  {Stack->push<int>(p.Fillrule()); return;}  
}

// pen linetype(string *s, bool scale);
void gen57(stack *Stack)
{
  bool scale = vm::pop<bool>(Stack);
  string * s = vm::pop<string *>(Stack);

  {Stack->push<pen>(pen(LineType(*s,scale))); return;} 
}

// string linetype(pen p);
void gen58(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  {Stack->push<string>(p.stroke()); return;}  
}

// pen linecap(int n);
void gen59(stack *Stack)
{
  int n = vm::pop<int>(Stack);

  {Stack->push<pen>(pen(setlinecap,n >= 0 && n < nCap ? n : DEFCAP)); return;}
}

// int linecap(pen p);
void gen60(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  {Stack->push<int>(p.cap()); return;}  
}

// pen linejoin(int n);
void gen61(stack *Stack)
{
  int n = vm::pop<int>(Stack);

  {Stack->push<pen>(pen(setlinejoin,n >= 0 && n < nJoin ? n : DEFJOIN)); return;}
}

// int linejoin(pen p);
void gen62(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  {Stack->push<int>(p.join()); return;}  
}

// pen linewidth(double x);
void gen63(stack *Stack)
{
  double x = vm::pop<double>(Stack);

  {Stack->push<pen>(pen(setlinewidth,x >= 0.0 ? x : DEFWIDTH)); return;}
}

// double linewidth(pen p);
void gen64(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  {Stack->push<double>(p.width()); return;}  
}

// pen fontcommand(string *s);
void gen65(stack *Stack)
{
  string * s = vm::pop<string *>(Stack);

  {Stack->push<pen>(pen(setfont,*s)); return;}
}

// string font(pen p);
void gen66(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  {Stack->push<string>(p.Font()); return;}
}

// pen fontsize(double size, double skip);
void gen67(stack *Stack)
{
  double skip = vm::pop<double>(Stack);
  double size = vm::pop<double>(Stack);

  {Stack->push<pen>(pen(setfontsize,size > 0.0 ? size : 0.0,
	     skip > 0.0 ? skip : 0.0)); return;}
}

// double fontsize(pen p);
void gen68(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  {Stack->push<double>(p.size()); return;}
}

// double lineskip(pen p);
void gen69(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  {Stack->push<double>(p.Lineskip()); return;}  
}

// pen overwrite(int n);
void gen70(stack *Stack)
{
  int n = vm::pop<int>(Stack);

  {Stack->push<pen>(pen(setoverwrite,n >= 0 && n < nOverwrite ? (overwrite_t) n :
	     DEFWRITE)); return;}
}

// int overwrite(pen p);
void gen71(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  {Stack->push<int>(p.Overwrite()); return;}  
}

// pen basealign(int n);
void gen72(stack *Stack)
{
  int n = vm::pop<int>(Stack);

  {Stack->push<pen>(pen(n >= 0 && n < nBaseLine ? (BaseLine) n : DEFBASE)); return;}
}

// int basealign(pen p);
void gen73(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  {Stack->push<int>(p.Baseline()); return;}
}

// path nib(pen p);
void gen74(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);

  static path nullpath;
  path *g=p.Path();
  {Stack->push<path>(g ? *g : nullpath); return;}
}

// pen makepen(path p);
void gen75(stack *Stack)
{
  path p = vm::pop<path>(Stack);

  {Stack->push<pen>(p.size() == 0 ? pen() : pen(new path(p))); return;}
}

// void _draw(picture *f, path g, pen p);
void gen76(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  path g = vm::pop<path>(Stack);
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawPath(g,p));
}

// void endclip(picture *f);
void gen77(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawClipEnd(false));
}

// void gsave(picture *f);
void gen78(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawGsave());
}

// void grestore(picture *f);
void gen79(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawGrestore());
}

// void begingroup(picture *f);
void gen80(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawBegin());
}

// void endgroup(picture *f);
void gen81(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);

  f->append(new drawEnd());
}

// void add(picture *dest, picture *src);
void gen82(stack *Stack)
{
  picture * src = vm::pop<picture *>(Stack);
  picture * dest = vm::pop<picture *>(Stack);

  dest->add(*src);
}

// void prepend(picture *dest, picture *src);
void gen83(stack *Stack)
{
  picture * src = vm::pop<picture *>(Stack);
  picture * dest = vm::pop<picture *>(Stack);

  dest->prepend(*src);
}

// string fileprefix();
void gen84(stack *Stack)
{

  {Stack->push<string>(getSetting<mem::string>("outname")); return;}
}


// Interactive mode
// bool interact();
void gen85(stack *Stack)
{

  {Stack->push<bool>(interact::interactive); return;}
}

// void uptodate(bool b);
void gen86(stack *Stack)
{
  bool b = vm::pop<bool>(Stack);

  interact::uptodate=b;
}

// bool uptodate();
void gen87(stack *Stack)
{

  {Stack->push<bool>(interact::uptodate); return;}
}


// System commands
// int system(string *str);
void gen88(stack *Stack)
{
  string * str = vm::pop<string *>(Stack);

  if(safe) error("system() call disabled; override with option -unsafe");
  else {Stack->push<int>(System(str->c_str())); return;}
}

// void abort(string *msg);
void gen89(stack *Stack)
{
  string * msg = vm::pop<string *>(Stack);

  error(msg->c_str());
}

// void _eval(string *s, bool embedded);
void gen90(stack *Stack)
{
  bool embedded = vm::pop<bool>(Stack);
  string * s = vm::pop<string *>(Stack);

  loop::doITree(parser::parseString(*s),embedded);
}

// void _eval(runnable *s, bool embedded);
void gen91(stack *Stack)
{
  bool embedded = vm::pop<bool>(Stack);
  runnable * s = vm::pop<runnable *>(Stack);

  loop::doIRunnable(s,embedded);
}

// void gui(double x=1);
void gen92(stack *Stack)
{
  double x = vm::pop<double>(Stack,1);
 
  Setting("deconstruct")=(x > 0.0 ? x : 0.0);
}

// bool deconstruct();
void gen93(stack *Stack)
{
 
  {Stack->push<bool>(getSetting<double>("deconstruct")); return;}
}

// void readGUI();
void gen94(stack *)
{

  static bool first=true;
  string name=buildname(getSetting<mem::string>("outname"),"gui");
  std::ifstream exists(name.c_str());
  if(exists) {
    if((getSetting<bool>("clearGUI") && !interact::interactive) ||
       (first && interact::interactive)) unlink(name.c_str());
    else {
      if (!getSetting<bool>("ignoreGUI")) {
	string cmd=string("include \"")+name+string("\";");
	absyntax::block *ast = parser::parseString(cmd);
	loop::doITree(ast,true);
      }
    }
  }
  first=false;
}

// Wrapper for the stack::load() method.
void loadModule(stack *Stack)
{
  string * index = vm::pop<string *>(Stack);

  Stack->load(*index);
}

// string cd(string *d);
void gen96(stack *Stack)
{
  string * d = vm::pop<string *>(Stack);

  int rc=setPath(d->c_str());
  if(rc != 0) {
    ostringstream buf;
    buf << "Cannot change to directory '" << *d << "'";
    error(buf.str().c_str());
  }
  char *p=getPath();
  if(p && interact::interactive) 
    cout << p << endl;
  {Stack->push<string>(p); return;}
}

// void scroll(int n);
void gen97(stack *Stack)
{
  int n = vm::pop<int>(Stack);

  settings::scrollLines=n;
}


// Path operations
void nullPath(stack *Stack)
{

  static path nullpath;
  {Stack->push<path>(nullpath); return;}
}

// pair point(path p, int n);
void gen99(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<pair>(p.point(n)); return;}
}

// pair point(path p, double t);
void gen100(stack *Stack)
{
  double t = vm::pop<double>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<pair>(p.point(t)); return;}
}

// pair precontrol(path p, int n);
void gen101(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<pair>(p.precontrol(n)); return;}
}

// pair precontrol(path p, double t);
void gen102(stack *Stack)
{
  double t = vm::pop<double>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<pair>(p.precontrol(t)); return;}
}

// pair postcontrol(path p, int n);
void gen103(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<pair>(p.postcontrol(n)); return;}
}

// pair postcontrol(path p, double t);
void gen104(stack *Stack)
{
  double t = vm::pop<double>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<pair>(p.postcontrol(t)); return;}
}

// pair dir(path p, int n);
void gen105(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<pair>(unit(p.direction(n))); return;}
}

// pair dir(path p, double t);
void gen106(stack *Stack)
{
  double t = vm::pop<double>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<pair>(unit(p.direction(t))); return;}
}

// path reverse(path p);
void gen107(stack *Stack)
{
  path p = vm::pop<path>(Stack);

  {Stack->push<path>(p.reverse()); return;}
}

// path subpath(path p, int b, int e);
void gen108(stack *Stack)
{
  int e = vm::pop<int>(Stack);
  int b = vm::pop<int>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<path>(p.subpath(b,e)); return;}
}

// path subpath(path p, double b, double e);
void gen109(stack *Stack)
{
  double e = vm::pop<double>(Stack);
  double b = vm::pop<double>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<path>(p.subpath(b,e)); return;}
}

// int length(path p);
void gen110(stack *Stack)
{
  path p = vm::pop<path>(Stack);

  {Stack->push<int>(p.length()); return;}
}

// bool cyclic(path p);
void gen111(stack *Stack)
{
  path p = vm::pop<path>(Stack);

  {Stack->push<bool>(p.cyclic()); return;}
}

// bool straight(path p, int i);
void gen112(stack *Stack)
{
  int i = vm::pop<int>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<bool>(p.straight(i)); return;}
}

// double arclength(path p);
void gen113(stack *Stack)
{
  path p = vm::pop<path>(Stack);

  {Stack->push<double>(p.arclength()); return;}
}

// double arctime(path p, double dval);
void gen114(stack *Stack)
{
  double dval = vm::pop<double>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<double>(p.arctime(dval)); return;}
}

// double dirtime(path p, pair z);
void gen115(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<double>(p.directiontime(z)); return;}
}

// pair intersect(path x, path y, double fuzz=0);
void gen116(stack *Stack)
{
  double fuzz = vm::pop<double>(Stack,0);
  path y = vm::pop<path>(Stack);
  path x = vm::pop<path>(Stack);

  {Stack->push<pair>(intersectiontime(x,y,fuzz)); return;}
}

// int size(path p);
void gen117(stack *Stack)
{
  path p = vm::pop<path>(Stack);

  {Stack->push<int>(p.size()); return;}
}

// path &(path p, path q);
void gen118(stack *Stack)
{
  path q = vm::pop<path>(Stack);
  path p = vm::pop<path>(Stack);

  {Stack->push<path>(camp::concat(p,q)); return;}
}

// pair min(path p);
void gen119(stack *Stack)
{
  path p = vm::pop<path>(Stack);

  {Stack->push<pair>(p.bounds().Min()); return;}
}

// pair max(path p);
void gen120(stack *Stack)
{
  path p = vm::pop<path>(Stack);

  {Stack->push<pair>(p.bounds().Max()); return;}
}

// double relativedistance(double theta, double phi, double t, bool atleast);
void gen121(stack *Stack)
{
  bool atleast = vm::pop<bool>(Stack);
  double t = vm::pop<double>(Stack);
  double phi = vm::pop<double>(Stack);
  double theta = vm::pop<double>(Stack);

  {Stack->push<double>(camp::velocity(theta,phi,tension(t,atleast))); return;}
}

// bool inside(patharray *g, pair z, pen p);
void gen122(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  pair z = vm::pop<pair>(Stack);
  patharray * g = vm::pop<patharray *>(Stack);

  array *G=copyArray(g);
  size_t size=G->size();
  int count=0;
  for(size_t i=0; i < size; i++) 
    count += read<path *>(G,i)->inside(z);
  {Stack->push<bool>(p.inside(count)); return;}
}


// Guide operations
void nullGuide(stack *Stack)
{

  {Stack->push<guide*>(new pathguide(path())); return;}
}

void dotsGuide(stack *Stack)
{
  guidearray * a = vm::pop<guidearray *>(Stack);

  guidevector v;
  size_t size=checkArray(a);
  for (size_t i=0; i < size; ++i)
    v.push_back(a->read<guide*>(i));

  {Stack->push<guide*>(new multiguide(v)); return;}
}

void dashesGuide(stack *Stack)
{
  guidearray * a = vm::pop<guidearray *>(Stack);

  static camp::curlSpec curly;
  static specguide curlout(&curly, camp::OUT);
  static specguide curlin(&curly, camp::IN);

  size_t n=checkArray(a);

  // a--b is equivalent to a{curl 1}..{curl 1}b
  guidevector v;
  if (n > 0)
    v.push_back(a->read<guide*>(0));

  if (n==1) {
    v.push_back(&curlout);
    v.push_back(&curlin);
  }
  else
    for (size_t i=1; i<n; ++i) {
      v.push_back(&curlout);
      v.push_back(&curlin);
      v.push_back(a->read<guide*>(i));
    }

  {Stack->push<guide*>(new multiguide(v)); return;}
}

// guide* operator cycle();
void gen126(stack *Stack)
{

  {Stack->push<guide*>(new cycletokguide()); return;}
}

// guide* operator spec(pair z, int p);
void gen127(stack *Stack)
{
  int p = vm::pop<int>(Stack);
  pair z = vm::pop<pair>(Stack);

  camp::side d=(camp::side) p;
  camp::dirSpec *sp=new camp::dirSpec(angle(z));

  {Stack->push<guide*>(new specguide(sp,d)); return;}
}

// guide* operator curl(double gamma, int p);
void gen128(stack *Stack)
{
  int p = vm::pop<int>(Stack);
  double gamma = vm::pop<double>(Stack);

  camp::side d=(camp::side) p;
  camp::curlSpec *sp=new camp::curlSpec(gamma);

  {Stack->push<guide*>(new specguide(sp,d)); return;}
}

// guide* operator tension(double tout, double tin, bool atleast);
void gen129(stack *Stack)
{
  bool atleast = vm::pop<bool>(Stack);
  double tin = vm::pop<double>(Stack);
  double tout = vm::pop<double>(Stack);

  tension Tin(tin, atleast),
         Tout(tout, atleast);

  {Stack->push<guide*>(new tensionguide(tout, tin)); return;}
}

// guide* operator controls(pair zout, pair zin);
void gen130(stack *Stack)
{
  pair zin = vm::pop<pair>(Stack);
  pair zout = vm::pop<pair>(Stack);

  {Stack->push<guide*>(new controlguide(zout, zin)); return;}
}


// String operations
void emptyString(stack *Stack)
{

  {Stack->push<string>(emptystring); return;}
}

// int length(string *s);
void gen132(stack *Stack)
{
  string * s = vm::pop<string *>(Stack);

  {Stack->push<int>((int) s->length()); return;}
}

// int find(string *s, string t, int pos=0);
void gen133(stack *Stack)
{
  int pos = vm::pop<int>(Stack,0);
  string t = vm::pop<string>(Stack);
  string * s = vm::pop<string *>(Stack);

  {Stack->push<int>((int) s->find(t,pos)); return;}
}

// int rfind(string *s, string t, int pos=-1);
void gen134(stack *Stack)
{
  int pos = vm::pop<int>(Stack,-1);
  string t = vm::pop<string>(Stack);
  string * s = vm::pop<string *>(Stack);

  {Stack->push<int>((int) s->rfind(t,pos)); return;}
}

// string reverse(string s);
void gen135(stack *Stack)
{
  string s = vm::pop<string>(Stack);

  reverse(s.begin(),s.end());
  {Stack->push<string>(s); return;}
}

// string insert(string s, int pos, string t);
void gen136(stack *Stack)
{
  string t = vm::pop<string>(Stack);
  int pos = vm::pop<int>(Stack);
  string s = vm::pop<string>(Stack);

  if ((size_t)pos < s.length())
    {Stack->push<string>(s.insert(pos,t)); return;}
  {Stack->push<string>(s); return;}
}

// string substr(string* s, int pos, int n=-1);
void gen137(stack *Stack)
{
  int n = vm::pop<int>(Stack,-1);
  int pos = vm::pop<int>(Stack);
  string* s = vm::pop<string*>(Stack);

  if ((size_t)pos < s->length())
    {Stack->push<string>(s->substr(pos,n)); return;}
  {Stack->push<string>(emptystring); return;}
}

// string erase(string s, int pos, int n);
void gen138(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  int pos = vm::pop<int>(Stack);
  string s = vm::pop<string>(Stack);

  if ((size_t)pos < s.length())
    {Stack->push<string>(s.erase(pos,n)); return;}
  {Stack->push<string>(s); return;} 
}

// returns a string constructed by translating all occurrences of the string
// from in an array of string pairs {from,to} to the string to in string s.
// string replace(string *S, stringarray2 *translate);
void gen139(stack *Stack)
{
  stringarray2 * translate = vm::pop<stringarray2 *>(Stack);
  string * S = vm::pop<string *>(Stack);

  size_t size=checkArray(translate);
  for(size_t i=0; i < size; i++) {
    array *a=read<array*>(translate,i);
    checkArray(a);
  }
  const char *p=S->c_str();
  ostringstream buf;
  while(*p) {
    for(size_t i=0; i < size;) {
      array *a=read<array*>(translate,i);
      string* from=read<string*>(a,0);
      size_t len=from->length();
      if(strncmp(p,from->c_str(),len) != 0) {i++; continue;}
      buf << read<string>(a,1);
      p += len;
      if(*p == 0) {Stack->push<string>(buf.str()); return;}
      i=0;
    }
    buf << *(p++);
  }
  {Stack->push<string>(buf.str()); return;}
}

// string format(string *format, int x);
void gen140(stack *Stack)
{
  int x = vm::pop<int>(Stack);
  string * format = vm::pop<string *>(Stack);

  int size=snprintf(NULL,0,format->c_str(),x)+1;
  if(size < 1) size=255; // Workaround for non-C99 compliant systems.
  char *buf=new char[size];
  snprintf(buf,size,format->c_str(),x);
  string s=string(buf);
  delete [] buf;
  {Stack->push<string>(s); return;}
}

// string format(string *format, double x);
void gen141(stack *Stack)
{
  double x = vm::pop<double>(Stack);
  string * format = vm::pop<string *>(Stack);

  ostringstream out;
  
  const char *phantom="\\phantom{+}";
  const char *p0=format->c_str();
  
  const char *p=p0;
  const char *start=NULL;
  while (*p != 0) {
    if(*p == '%') {
      p++;
      if(*p != '%') {start=p-1; break;}
    }
    out << *(p++);
  }
  
  if(!start) {Stack->push<string>(out.str()); return;}
  
  // Allow at most 1 argument  
  while (*p != 0) {
    if(*p == '*' || *p == '$') {Stack->push<string>(out.str()); return;}
    if(isupper(*p) || islower(*p)) {p++; break;}
    p++;
  }
  
  const char *tail=p;
  string f=format->substr(start-p0,tail-start);
  int size=snprintf(NULL,0,f.c_str(),x)+1;
  if(size < 1) size=255; // Workaround for non-C99 compliant systems.
  char *buf=new char[size];
  snprintf(buf,size,f.c_str(),x);

  bool trailingzero=f.find("#") < string::npos;
  bool plus=f.find("+") < string::npos;
  bool space=f.find(" ") < string::npos;
  
  char *q=buf; // beginning of formatted number

  if(*q == ' ') {
    out << phantom;
    q++;
  }
  
  // Remove any spurious sign
  if(*q == '-' || *q == '+') {
    p=q+1;
    bool zero=true;
    while(*p != 0) {
      if(!isdigit(*p) && *p != '.') break;
      if(isdigit(*p) && *p != '0') {zero=false; break;}
      p++;
    }
    if(zero) {
      q++;
      if(plus || space) out << phantom;
    }
  }
  
  const char *r=p=q;
  bool dp=false;
  while(*r != 0 && (isdigit(*r) || *r == '.' || *r == '+' || *r == '-')) {
    if(*r == '.') dp=true;
    r++;
  }
  if(dp) { // Remove trailing zeros and/or decimal point
    r--;
    unsigned int n=0;
    while(r > q && *r == '0') {r--; n++;}
    if(*r == '.') {r--; n++;}
    while(q <= r) out << *(q++);
    if(!trailingzero) q += n;
  }
  
  bool zero=(r == p && *r == '0') && !trailingzero;
  
  // Translate "E+/E-/e+/e-" exponential notation to TeX
  while(*q != 0) {
    if((*q == 'E' || *q == 'e') && (*(q+1) == '+' || *(q+1) == '-')) {
      if(!zero) out << "\\!\\times\\!10^{";
      bool plus=(*(q+1) == '+');
      q++;
      if(plus) q++;
      if(*q == '-') out << *(q++);
      while(*q == '0' && (zero || isdigit(*(q+1)))) q++;
      while(isdigit(*q)) out << *(q++);
      if(!zero) {
	if(plus) out << phantom;
	out << "}";
      }
      break;
    }
    out << *(q++);
  }
  
  while(*tail != 0) 
    out << *(tail++);
  
  delete [] buf;
  {Stack->push<string>(out.str()); return;}
}

// string time(string *format);
void gen142(stack *Stack)
{
  string * format = vm::pop<string *>(Stack);

#ifdef HAVE_STRFTIME
  static const size_t n=256;
  static char Time[n];
  const time_t bintime=time(NULL);
  strftime(Time,n,format->c_str(),localtime(&bintime));
  {Stack->push<string>(Time); return;}
#else  
  {Stack->push<string>(*format); return;}
#endif  
}


// Math
// double ^(double x, int y);
void gen143(stack *Stack)
{
  int y = vm::pop<int>(Stack);
  double x = vm::pop<double>(Stack);

  {Stack->push<double>(pow(x,y)); return;}
}

// int quotient(int x, int y);
void gen144(stack *Stack)
{
  int y = vm::pop<int>(Stack);
  int x = vm::pop<int>(Stack);
 
  if (y == 0) dividebyzero();
// Implementation-independent definition of integer division: round down
  {Stack->push<int>((x-portableMod(x,y))/y); return;}
}

// int abs(int x);
void gen145(stack *Stack)
{
  int x = vm::pop<int>(Stack);
 
  {Stack->push<int>(abs(x)); return;}
}

// int sgn(double x);
void gen146(stack *Stack)
{
  double x = vm::pop<double>(Stack);
 
  {Stack->push<int>(sgn(x)); return;}
}

// int rand();
void gen147(stack *Stack)
{
 
  {Stack->push<int>(rand()); return;}
}

// void srand(int seed);
void gen148(stack *Stack)
{
  int seed = vm::pop<int>(Stack);
 
  srand(seed);
}

// int ceil(double x);
void gen149(stack *Stack)
{
  double x = vm::pop<double>(Stack);
 
  double y=ceil(x);
  checkint(y,0);
  {Stack->push<int>((int) y); return;}
}

// int floor(double x);
void gen150(stack *Stack)
{
  double x = vm::pop<double>(Stack);
 
  double y=floor(x);
  checkint(y,0);
  {Stack->push<int>((int) y); return;}
}

// int round(double x);
void gen151(stack *Stack)
{
  double x = vm::pop<double>(Stack);
 
  if(fabs(x) >= INT_MAX+0.5) integeroverflow(0);
  {Stack->push<int>(Round(x)); return;}
}

// int Ceil(double x);
void gen152(stack *Stack)
{
  double x = vm::pop<double>(Stack);
 
  {Stack->push<int>(Ceil(x)); return;}
}

// int Floor(double x);
void gen153(stack *Stack)
{
  double x = vm::pop<double>(Stack);
 
  {Stack->push<int>(Floor(x)); return;}
}

// int Round(double x);
void gen154(stack *Stack)
{
  double x = vm::pop<double>(Stack);
 
  {Stack->push<int>(Round(intcap(x))); return;}
}

// double fmod(double x, double y);
void gen155(stack *Stack)
{
  double y = vm::pop<double>(Stack);
  double x = vm::pop<double>(Stack);

  if (y == 0.0) dividebyzero();
  {Stack->push<double>(fmod(x,y)); return;}
}

// double atan2(double y, double x);
void gen156(stack *Stack)
{
  double x = vm::pop<double>(Stack);
  double y = vm::pop<double>(Stack);
 
  {Stack->push<double>(atan2(y,x)); return;}
}

// double hypot(double x, double y);
void gen157(stack *Stack)
{
  double y = vm::pop<double>(Stack);
  double x = vm::pop<double>(Stack);
 
  {Stack->push<double>(hypot(x,y)); return;}
}

// double remainder(double x, double y);
void gen158(stack *Stack)
{
  double y = vm::pop<double>(Stack);
  double x = vm::pop<double>(Stack);
 
  {Stack->push<double>(remainder(x,y)); return;}
}

// double J(int n, double x);
void gen159(stack *Stack)
{
  double x = vm::pop<double>(Stack);
  int n = vm::pop<int>(Stack);

  {Stack->push<double>(jn(n,x)); return;}
}

// double Y(int n, double x);
void gen160(stack *Stack)
{
  double x = vm::pop<double>(Stack);
  int n = vm::pop<int>(Stack);

  {Stack->push<double>(yn(n,x)); return;}
}

// double erf(double x);
void gen161(stack *Stack)
{
  double x = vm::pop<double>(Stack);

  {Stack->push<double>(erf(x)); return;}
}

// double erfc(double x);
void gen162(stack *Stack)
{
  double x = vm::pop<double>(Stack);

  {Stack->push<double>(erfc(x)); return;}
}

// double gamma(double x);
void gen163(stack *Stack)
{
  double x = vm::pop<double>(Stack);

#ifdef HAVE_TGAMMA
  {Stack->push<double>(tgamma(x)); return;}
#else
 double lg = lgamma(x);
 {Stack->push<double>(signgam*exp(lg)); return;}
#endif
}

// realarray* quadraticroots(double a, double b, double c);
void gen164(stack *Stack)
{
  double c = vm::pop<double>(Stack);
  double b = vm::pop<double>(Stack);
  double a = vm::pop<double>(Stack);

  quadraticroots q(a,b,c);
  array *roots=new array(q.roots);
  if(q.roots >= 1) (*roots)[0]=q.t1;
  if(q.roots == 2) (*roots)[1]=q.t2;
  {Stack->push<realarray*>(roots); return;}
}

// realarray* cubicroots(double a, double b, double c, double d);
void gen165(stack *Stack)
{
  double d = vm::pop<double>(Stack);
  double c = vm::pop<double>(Stack);
  double b = vm::pop<double>(Stack);
  double a = vm::pop<double>(Stack);

  cubicroots q(a,b,c,d);
  array *roots=new array(q.roots);
  if(q.roots >= 1) (*roots)[0]=q.t1;
  if(q.roots >= 2) (*roots)[1]=q.t2;
  if(q.roots == 3) (*roots)[2]=q.t3;
  {Stack->push<realarray*>(roots); return;}
}

  
// Transforms
// bool ==(transform a, transform b);
void gen166(stack *Stack)
{
  transform b = vm::pop<transform>(Stack);
  transform a = vm::pop<transform>(Stack);

  {Stack->push<bool>(a == b); return;}
}

// bool !=(transform a, transform b);
void gen167(stack *Stack)
{
  transform b = vm::pop<transform>(Stack);
  transform a = vm::pop<transform>(Stack);

  {Stack->push<bool>(a != b); return;}
}

// transform *(transform a, transform b);
void gen168(stack *Stack)
{
  transform b = vm::pop<transform>(Stack);
  transform a = vm::pop<transform>(Stack);

  {Stack->push<transform>(a*b); return;}
}

// pair *(transform t, pair z);
void gen169(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);
  transform t = vm::pop<transform>(Stack);

  {Stack->push<pair>(t*z); return;}
}

// path *(transform t, path g);
void gen170(stack *Stack)
{
  path g = vm::pop<path>(Stack);
  transform t = vm::pop<transform>(Stack);

  {Stack->push<path>(transformed(t,g)); return;}
}

// pen *(transform t, pen p);
void gen171(stack *Stack)
{
  pen p = vm::pop<pen>(Stack);
  transform t = vm::pop<transform>(Stack);

  {Stack->push<pen>(transformed(t,p)); return;}
}

// picture* *(transform t, picture *f);
void gen172(stack *Stack)
{
  picture * f = vm::pop<picture *>(Stack);
  transform t = vm::pop<transform>(Stack);

  {Stack->push<picture*>(transformed(t,f)); return;}
}

// transform ^(transform t, int n);
void gen173(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  transform t = vm::pop<transform>(Stack);

  transform T;
  if(n < 0) {
    n=-n;
    t=inverse(t);
  }
  for(int i=0; i < n; i++) T=T*t;
  {Stack->push<transform>(T); return;}
}

void transformXPart(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);

  {Stack->push<double>(t.getx()); return;}
}

void transformYPart(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);

  {Stack->push<double>(t.gety()); return;}
}

void transformXXPart(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);

  {Stack->push<double>(t.getxx()); return;}
}

void transformXYPart(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);

  {Stack->push<double>(t.getxy()); return;}
}

void transformYXPart(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);

  {Stack->push<double>(t.getyx()); return;}
}

void transformYYPart(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);

  {Stack->push<double>(t.getyy()); return;}
}

void real6ToTransform(stack *Stack)
{
  double yy = vm::pop<double>(Stack);
  double yx = vm::pop<double>(Stack);
  double xy = vm::pop<double>(Stack);
  double xx = vm::pop<double>(Stack);
  double y = vm::pop<double>(Stack);
  double x = vm::pop<double>(Stack);

  {Stack->push<transform>(transform(x,y,xx,xy,yx,yy)); return;}
}

// transform identity();
void transformIdentity(stack *Stack)
{

  {Stack->push<transform>(identity()); return;}
}

// transform inverse(transform t);
void gen182(stack *Stack)
{
  transform t = vm::pop<transform>(Stack);

  {Stack->push<transform>(inverse(t)); return;}
}

// transform shift(pair z);
void gen183(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);

  {Stack->push<transform>(shift(z)); return;}
}

// transform xscale(double x);
void gen184(stack *Stack)
{
  double x = vm::pop<double>(Stack);

  {Stack->push<transform>(xscale(x)); return;}
}

// transform yscale(double y);
void gen185(stack *Stack)
{
  double y = vm::pop<double>(Stack);

  {Stack->push<transform>(yscale(y)); return;}
}

// transform scale(double x);
void gen186(stack *Stack)
{
  double x = vm::pop<double>(Stack);

  {Stack->push<transform>(scale(x)); return;}
}

// transform slant(double s);
void gen187(stack *Stack)
{
  double s = vm::pop<double>(Stack);

  {Stack->push<transform>(slant(s)); return;}
}

// transform rotate(double angle, pair z=0);
void gen188(stack *Stack)
{
  pair z = vm::pop<pair>(Stack,0);
  double angle = vm::pop<double>(Stack);

  {Stack->push<transform>(rotatearound(z,radians(angle))); return;}
}

// transform reflect(pair a, pair b);
void gen189(stack *Stack)
{
  pair b = vm::pop<pair>(Stack);
  pair a = vm::pop<pair>(Stack);

  {Stack->push<transform>(reflectabout(a,b)); return;}
}


// Pair operations
void pairZero(stack *Stack)
{

  static pair zero;
  {Stack->push<pair>(zero); return;}
}

void realRealToPair(stack *Stack)
{
  double y = vm::pop<double>(Stack);
  double x = vm::pop<double>(Stack);

  {Stack->push<pair>(pair(x,y)); return;}
}

void pairNegate(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);

  {Stack->push<pair>(-z); return;}
}

void pairXPart(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);

  {Stack->push<double>(z.getx()); return;}
}

void pairYPart(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);

  {Stack->push<double>(z.gety()); return;}
}

// double length(pair z);
void gen195(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);

  {Stack->push<double>(z.length()); return;}
}

// double abs(pair z);
void gen196(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);

  {Stack->push<double>(z.length()); return;}
}

// double angle(pair z);
void gen197(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);

  {Stack->push<double>(z.angle()); return;}
}

// Return the angle of z in degrees in the interval [0,360).
// double degrees(pair z);
void gen198(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);

  double deg=degrees(z.angle());
  if(deg < 0) deg += 360; 
  {Stack->push<double>(deg); return;}
}

// pair unit(pair z);
void gen199(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);

  {Stack->push<pair>(unit(z)); return;}
}

// pair dir(double theta);
void gen200(stack *Stack)
{
  double theta = vm::pop<double>(Stack);

  {Stack->push<pair>(expi(radians(theta))); return;}
}

// pair expi(double theta);
void gen201(stack *Stack)
{
  double theta = vm::pop<double>(Stack);

  {Stack->push<pair>(expi(theta)); return;}
}

// pair conj(pair z);
void gen202(stack *Stack)
{
  pair z = vm::pop<pair>(Stack);

  {Stack->push<pair>(conj(z)); return;}
}

// To avoid confusion, a dot product requires explicit pair arguments.
// double dot(explicit pair u, explicit pair v);
void gen203(stack *Stack)
{
  pair v = vm::pop<pair>(Stack);
  pair u = vm::pop<pair>(Stack);

  {Stack->push<double>(u.getx()*v.getx()+u.gety()*v.gety()); return;}
}


// Triple operations
void tripleZero(stack *Stack)
{

  static triple zero;
  {Stack->push<triple>(zero); return;}
}

void realRealRealToTriple(stack *Stack)
{
  double z = vm::pop<double>(Stack);
  double y = vm::pop<double>(Stack);
  double x = vm::pop<double>(Stack);

  {Stack->push<triple>(triple(x,y,z)); return;}
}

void tripleXPart(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);

  {Stack->push<double>(v.getx()); return;}
}

void tripleYPart(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);

  {Stack->push<double>(v.gety()); return;}
}

void tripleZPart(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);

  {Stack->push<double>(v.getz()); return;}
}

// triple *(double x, triple v);
void gen209(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
  double x = vm::pop<double>(Stack);

  {Stack->push<triple>(x*v); return;}
}

// triple *(triple v, double x);
void gen210(stack *Stack)
{
  double x = vm::pop<double>(Stack);
  triple v = vm::pop<triple>(Stack);

  {Stack->push<triple>(x*v); return;}
}

// triple /(triple v, double x);
void gen211(stack *Stack)
{
  double x = vm::pop<double>(Stack);
  triple v = vm::pop<triple>(Stack);

  {Stack->push<triple>(v/x); return;}
}

// double length(triple v);
void gen212(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);

  {Stack->push<double>(v.length()); return;}
}

// double abs(triple v);
void gen213(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);

  {Stack->push<double>(v.length()); return;}
}

// double polar(triple v);
void gen214(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);

  {Stack->push<double>(v.polar()); return;}
}

// double azimuth(triple v);
void gen215(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);

  {Stack->push<double>(v.azimuth()); return;}
}

// double colatitude(triple v);
void gen216(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);

  {Stack->push<double>(degrees(v.polar())); return;}
}

// double latitude(triple v);
void gen217(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);

  {Stack->push<double>(90.0-degrees(v.polar())); return;}
}

// double longitude(triple v);
void gen218(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);

  double deg=degrees(v.azimuth());
  if(deg < 0) deg += 360; 
  {Stack->push<double>(deg); return;}
}

// triple unit(triple v);
void gen219(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);

  {Stack->push<triple>(unit(v)); return;}
}

// double dot(triple u, triple v);
void gen220(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
  triple u = vm::pop<triple>(Stack);

  {Stack->push<double>(u.getx()*v.getx()+u.gety()*v.gety()+u.getz()*v.getz()); return;}
}

// triple cross(triple u, triple v);
void gen221(stack *Stack)
{
  triple v = vm::pop<triple>(Stack);
  triple u = vm::pop<triple>(Stack);

  {Stack->push<triple>(triple(u.gety()*v.getz()-u.getz()*v.gety(),
		u.getz()*v.getx()-u.getx()*v.getz(),
		u.getx()*v.gety()-v.getx()*u.gety())); return;}
}

// triple expi(double theta, double phi);
void gen222(stack *Stack)
{
  double phi = vm::pop<double>(Stack);
  double theta = vm::pop<double>(Stack);

  {Stack->push<triple>(expi(theta,phi)); return;}
  double sintheta=sin(theta);
  {Stack->push<triple>(triple(sintheta*cos(phi),sintheta*sin(phi),cos(theta))); return;}
}

// triple dir(double theta, double phi);
void gen223(stack *Stack)
{
  double phi = vm::pop<double>(Stack);
  double theta = vm::pop<double>(Stack);

  {Stack->push<triple>(expi(radians(theta),radians(phi))); return;}
}

// double cubiclength(triple z0, triple z0p, triple z1m, triple z1, double goal);
void gen224(stack *Stack)
{
  double goal = vm::pop<double>(Stack);
  triple z1 = vm::pop<triple>(Stack);
  triple z1m = vm::pop<triple>(Stack);
  triple z0p = vm::pop<triple>(Stack);
  triple z0 = vm::pop<triple>(Stack);

  {Stack->push<double>(cubiclength(z0,z0p,z1m,z1,goal)); return;}
}

// pair intersect(triplearray* pre1, triplearray* point1, triplearray* post1,               triplearray* pre2, triplearray* point2, triplearray* post2,	       double fuzz);
void gen225(stack *Stack)
{
  double fuzz = vm::pop<double>(Stack);
  triplearray* post2 = vm::pop<triplearray*>(Stack);
  triplearray* point2 = vm::pop<triplearray*>(Stack);
  triplearray* pre2 = vm::pop<triplearray*>(Stack);
  triplearray* post1 = vm::pop<triplearray*>(Stack);
  triplearray* point1 = vm::pop<triplearray*>(Stack);
  triplearray* pre1 = vm::pop<triplearray*>(Stack);

  size_t size1=checkArrays(pre1,point1);
  size_t size2=checkArrays(pre2,point2);
      
  if(checkArray(post1) != size1 || checkArray(post2) != size2)
    vm::error(arraymismatch);
  
  int single1=(size1 == 1);
  int single2=(size2 == 1);
  
  size_t Size1=size1+single1;
  size_t Size2=size2+single2;
  
  node *n1=new node[Size1];
  node *n2=new node[Size2];
      
  for(size_t i=0; i < size1; ++i)
    n1[i]=node(read<triple>(pre1,i),read<triple>(point1,i),
	       read<triple>(post1,i));

  for(size_t i=0; i < size2; ++i)
    n2[i]=node(read<triple>(pre2,i),read<triple>(point2,i),
	       read<triple>(post2,i));

  if(single1) n1[1]=n1[0];
  if(single2) n2[1]=n2[0];
  
  {Stack->push<pair>(intersect((int) Size1-1,(int) Size2-1,n1,n2,fuzz)); return;}
}


// System routines
// string VERSION();
void gen226(stack *Stack)
{

  {Stack->push<string>(VERSION); return;}
}

// void quiet(bool v);
void gen227(stack *Stack)
{
  bool v = vm::pop<bool>(Stack);

  Setting("interactiveView")=
    Setting("batchView")=
    Setting("oneFileView")=!v;
}

// void atexit(callable *f);
void gen228(stack *Stack)
{
  callable * f = vm::pop<callable *>(Stack);

  atExitFunction=f;
}

// callable* atexit();
void gen229(stack *Stack)
{

  {Stack->push<callable*>(atExitFunction); return;}
}


// Merge output files  
// int merge(stringarray *files, string *args, string *format, bool keep);
void gen230(stack *Stack)
{
  bool keep = vm::pop<bool>(Stack);
  string * format = vm::pop<string *>(Stack);
  string * args = vm::pop<string *>(Stack);
  stringarray * files = vm::pop<stringarray *>(Stack);

  int ret;
  
  size_t size=checkArray(files);
  
  if(!checkFormatString(*format)) return;
  
  ostringstream cmd,remove;
  cmd << getSetting<mem::string>("convert") << " "+*args;
  
  for(size_t i=0; i < size; i++) 
    cmd << " " << read<string>(files,i);
  
  string name=buildname(getSetting<mem::string>("outname"),format->c_str());
  cmd << " " << name;
  ret=System(cmd,false,true,"convert");
  
  if(ret == 0)
    if(verbose > 0) cout << "Wrote " << name << endl;
  
  if(!keep && !getSetting<bool>("keep"))
    for(size_t i=0; i < size; i++) 
      unlink(read<string>(files,i).c_str());
    
  if(ret == 0 && settings::view()) {
    ostringstream cmd;
    cmd << getSetting<mem::string>("animate") << " " << name;
    System(cmd,false,false,"animate","your animated GIF viewer");
  }
  
  {Stack->push<int>(ret); return;}
}


// Array operations

// Create an empty array.
void emptyArray(stack *Stack)
{

  {Stack->push<array*>(new array(0)); return;}
}

// Create a new array (technically a vector).
// This array will be multidimensional.  First the number of dimensions
// is popped off the stack, followed by each dimension in reverse order.
// The array itself is technically a one dimensional array of one
// dimension arrays and so on.
void newDeepArray(stack *Stack)
{
  int depth = vm::pop<int>(Stack);

  assert(depth > 0);

  int *dims = new int[depth];

  for (int index = depth-1; index >= 0; index--)
    dims[index] = pop<int>(Stack);

  array *a=deepArray(depth, dims);
  delete [] dims;
  {Stack->push<array*>(a); return;}
}

// Creates an array with elements already specified.  First, the number
// of elements is popped off the stack, followed by each element in
// reverse order.
void newInitializedArray(stack *Stack)
{
  int n = vm::pop<int>(Stack);

  assert(n >= 0);

  array *a = new array(n);

  for (int index = n-1; index >= 0; index--)
    (*a)[index] = pop(Stack);

  {Stack->push<array*>(a); return;}
}

// Similar to newInitializedArray, but after the n elements, append another
// array to it.
void newAppendedArray(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  array* tail = vm::pop<array*>(Stack);

  assert(n >= 0);

  array *a = new array(n);

  for (int index = n-1; index >= 0; index--)
    (*a)[index] = pop(Stack);
  
  copy(tail->begin(), tail->end(), back_inserter(*a));

  {Stack->push<array*>(a); return;}
}

// Read an element from an array. Checks for initialization & bounds.
void arrayRead(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  array * a = vm::pop<array *>(Stack);

  item& i=arrayRead(a,n);
  if (i.empty()) {
    ostringstream buf;
    buf << "read uninitialized value from array at index " << n;
    error(buf.str().c_str());
  }
  {Stack->push(i); return;}
}

// Read an element from an array of arrays. Check bounds and initialize
// as necessary.
void arrayArrayRead(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  array * a = vm::pop<array *>(Stack);

  item& i=arrayRead(a,n);
  if (i.empty()) i=new array(0);
  {Stack->push(i); return;}
}

// Write an element to an array.  Increase size if necessary.
void arrayWrite(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  array * a = vm::pop<array *>(Stack);
  item value = vm::pop(Stack);

  size_t len=checkArray(a);
  bool cyclic=a->cyclic();
  if(cyclic && len > 0) n=imod(n,len);
  else {
    if(cyclic) outOfBounds("writing cyclic",len,n);
    if(n < 0) outOfBounds("writing",len,n);
    if(a->size() <= (size_t) n)
      a->resize(n+1);
  }
  (*a)[n] = value;
  {Stack->push(value); return;}
}

// Returns the length of an array.
void arrayLength(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);

  {Stack->push<int>((int) checkArray(a)); return;}
}

// Return the cyclic flag for an array.
void arrayCyclicFlag(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);

  checkArray(a);
  {Stack->push<bool>(a->cyclic()); return;}
}

// The helper function for the cyclic method that sets the cyclic flag.
void arrayCyclicHelper(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
  bool b = vm::pop<bool>(Stack);

  checkArray(a);
  a->cyclic(b);
}

// Set the cyclic flag for an array.
void arrayCyclic(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);

  checkArray(a);
  {Stack->push<callable*>(new thunk(new bfunc(arrayCyclicHelper),a)); return;}
}

// The helper function for the push method that does the actual operation.
void arrayPushHelper(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
  item i = vm::pop(Stack);

  checkArray(a);
  a->push(i);
  {Stack->push(i); return;}
}

// Returns the push method for an array.
void arrayPush(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);

  checkArray(a);
  {Stack->push<callable*>(new thunk(new bfunc(arrayPushHelper),a)); return;}
}

// The helper function for the append method that appends b to a.
void arrayAppendHelper(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
  array * b = vm::pop<array *>(Stack);

  checkArray(a);
  size_t size=checkArray(b);
  for(size_t i=0; i < size; i++)
    a->push((*b)[i]);
}

// Returns the append method for an array.
void arrayAppend(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);

  checkArray(a);
  {Stack->push<callable*>(new thunk(new bfunc(arrayAppendHelper),a)); return;}
}

// The helper function for the pop method.
void arrayPopHelper(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);

  checkArray(a);
  if(a->size() == 0) 
    error("cannot pop element from empty array");
  {Stack->push(a->pop()); return;}
}

// Returns the pop method for an array.
void arrayPop(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);

  checkArray(a);
  {Stack->push<callable*>(new thunk(new bfunc(arrayPopHelper),a)); return;}
}

void arrayAlias(stack *Stack)
{
  array * b = vm::pop<array *>(Stack);
  array * a = vm::pop<array *>(Stack);

  {Stack->push<bool>(a==b); return;}
}

// Return array formed by indexing array a with elements of integer array b
void arrayIntArray(stack *Stack)
{
  array * b = vm::pop<array *>(Stack);
  array * a = vm::pop<array *>(Stack);

  size_t asize=checkArray(a);
  size_t bsize=checkArray(b);
  array *r=new array(bsize);
  for(size_t i=0; i < bsize; i++) {
    int index=read<int>(b,i);
    if(index < 0) index += (int) asize;
    if(index < 0 || index >= (int) asize)
      error("reading out-of-bounds index from array");
    (*r)[i]=(*a)[index];
  }
  {Stack->push<array*>(r); return;}
}

// Generate the sequence {f_i : i=0,1,...n-1} given a function f and integer n
void arraySequence(stack *Stack)
{
  int n = vm::pop<int>(Stack);
  callable * f = vm::pop<callable *>(Stack);

  if(n < 0) n=0;
  array *a=new array(n);
  for(int i=0; i < n; ++i) {
    Stack->push(i);
    f->call(Stack);
    (*a)[i]=pop(Stack);
  }
  {Stack->push<intarray*>(a); return;}
}

// Return the array {0,1,...n-1}
// intarray* sequence(int n);
void gen251(stack *Stack)
{
  int n = vm::pop<int>(Stack);

  if(n < 0) n=0;
  array *a=new array(n);
  for(int i=0; i < n; ++i) {
    (*a)[i]=i;
  }
  {Stack->push<intarray*>(a); return;}
}

// Apply a function to each element of an array
void arrayFunction(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);
  callable * f = vm::pop<callable *>(Stack);

  size_t size=checkArray(a);
  array *b=new array(size);
  for(size_t i=0; i < size; ++i) {
    Stack->push((*a)[i]);
    f->call(Stack);
    (*b)[i]=pop(Stack);
  }
  {Stack->push<array*>(b); return;}
}

// bool all(boolarray *a);
void gen253(stack *Stack)
{
  boolarray * a = vm::pop<boolarray *>(Stack);

  size_t size=checkArray(a);
  bool c=true;
  for(size_t i=0; i < size; i++)
    if(!get<bool>((*a)[i])) {c=false; break;}
  {Stack->push<bool>(c); return;}
}

// boolarray* !(boolarray* a);
void gen254(stack *Stack)
{
  boolarray* a = vm::pop<boolarray*>(Stack);

  size_t size=checkArray(a);
  array *c=new array(size);
  for(size_t i=0; i < size; i++)
    (*c)[i]=!read<bool>(a,i);
  {Stack->push<boolarray*>(c); return;}
}

// int sum(boolarray *a);
void gen255(stack *Stack)
{
  boolarray * a = vm::pop<boolarray *>(Stack);

  size_t size=checkArray(a);
  int sum=0;
  for(size_t i=0; i < size; i++)
    sum += read<bool>(a,i) ? 1 : 0;
  {Stack->push<int>(sum); return;}
}

void arrayCopy(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);

  {Stack->push<array*>(copyArray(a)); return;}
}

void arrayConcat(stack *Stack)
{
  array * b = vm::pop<array *>(Stack);
  array * a = vm::pop<array *>(Stack);

  size_t asize=checkArray(a);
  size_t bsize=checkArray(b);
  array *c=new array(asize+bsize);
  for(size_t i=0; i < asize; i++) 
    (*c)[i]=(*a)[i];
  for(size_t i=0; i < bsize; i++, asize++) 
    (*c)[asize]=(*b)[i];
  {Stack->push<array*>(c); return;}
}

void array2Copy(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);

  {Stack->push<array*>(copyArray2(a)); return;}
}

void array2Transpose(stack *Stack)
{
  array * a = vm::pop<array *>(Stack);

  size_t asize=checkArray(a);
  array *c=new array(0);
  for(size_t i=0; i < asize; i++) {
    size_t ip=i+1;
    array *ai=read<array*>(a,i);
    size_t aisize=checkArray(ai);
    size_t csize=c->size();
    if(csize < aisize) {
      c->resize(aisize);
      for(size_t j=csize; j < aisize; j++) {
	(*c)[j]=new array(ip);
      }
    }
    for(size_t j=0; j < aisize; j++) {
    array *cj=read<array*>(c,j);
    if(cj->size() < ip) cj->resize(ip);
    (*cj)[i]=(*ai)[j];
    }
  }
  {Stack->push<array*>(c); return;}
}

// In a boolean array, find the index of the nth true value or -1 if not found
// If n is negative, search backwards.
// int find(boolarray *a, int n=1);
void gen260(stack *Stack)
{
  int n = vm::pop<int>(Stack,1);
  boolarray * a = vm::pop<boolarray *>(Stack);

  
  size_t size=checkArray(a);
  int j=-1;
  if(n > 0)
    for(size_t i=0; i < size; i++)
      if(read<bool>(a,i)) {
	n--; if(n == 0) {j=(int) i; break;}
      }
  if(n < 0)
    for(size_t i=size; i > 0;)
      if(read<bool>(a,--i)) {
	n++; if(n == 0) {j=(int) i; break;}
      }
  {Stack->push<int>(j); return;}
}

// construct vector obtained by replacing those elements of b for which the
// corresponding elements of a are false by the corresponding element of c.
void arrayConditional(stack *Stack)
{
  array * c = vm::pop<array *>(Stack);
  array * b = vm::pop<array *>(Stack);
  array * a = vm::pop<array *>(Stack);

  size_t size=a->size();
  array *r=new array(size);
  if(b && c) {
    checkArrays(a,b);
    checkArrays(b,c);
    for(size_t i=0; i < size; i++)
      (*r)[i]=read<bool>(a,i) ? (*b)[i] : (*c)[i];
  } else {
    r->clear();
    if(b) {
      checkArrays(a,b);
      for(size_t i=0; i < size; i++)
        if(read<bool>(a,i)) r->push((*b)[i]);
    } else if(c) {
      checkArrays(a,c);
      for(size_t i=0; i < size; i++)
        if(!read<bool>(a,i)) r->push((*c)[i]);
    }
  }
  {Stack->push<array*>(r); return;}
}

// Solve the problem L\inv f, where f is an n vector and L is the n x n matrix
//
// [ b[0] c[0]           a[0]   ]
// [ a[1] b[1] c[1]             ]
// [      a[2] b[2] c[2]        ]
// [                ...         ]
// [       c[n-1] a[n-1] b[n-1] ]
// realarray* tridiagonal(realarray *a, realarray *b, realarray *c, realarray *f);
void gen262(stack *Stack)
{
  realarray * f = vm::pop<realarray *>(Stack);
  realarray * c = vm::pop<realarray *>(Stack);
  realarray * b = vm::pop<realarray *>(Stack);
  realarray * a = vm::pop<realarray *>(Stack);

  size_t n=checkArrays(a,b);
  if(n != checkArray(c) || n != checkArray(f))
    vm::error(arraymismatch);
  
  array *up=new array(n);
  array& u=*up;

  if(n == 0) {Stack->push<realarray*>(up); return;}
  
  // Special case: Zero Dirichlet boundary conditions
  if(read<double>(a,0) == 0.0 && read<double>(c,n-1) == 0.0) {
    static double *work;
    static size_t size=0;
  
    CheckReallocate(work,n,size);
    
    double temp=1.0/read<double>(b,0);
    u[0]=read<double>(f,0)*temp;
    work[0]=-read<double>(c,0)*temp;
	
    for(size_t i=1; i < n; i++) {
      double temp=1.0/(read<double>(b,i)+read<double>(a,i)*work[i-1]);
      u[i]=(read<double>(f,i)-read<double>(a,i)*read<double>(u,i-1))*temp;
      work[i]=-read<double>(c,i)*temp;
    }

    for(size_t i=n-1; i >= 1; i--)
      u[i-1]=read<double>(u,i-1)+work[i-1]*read<double>(u,i);
    {Stack->push<realarray*>(up); return;}
  }
  
  double binv=read<double>(b,0);
  if(binv == 0.0) dividebyzero();
  binv=1.0/binv;
  
  if(n == 1) {u[0]=read<double>(f,0)*binv; {Stack->push<realarray*>(up); return;}}
  if(n == 2) {
    double factor=(read<double>(b,0)*read<double>(b,1)-
		   read<double>(a,0)*read<double>(c,1));
    if(factor== 0.0) dividebyzero();
    factor=1.0/factor;
    double temp=(read<double>(b,0)*read<double>(f,1)-
	  read<double>(c,1)*read<double>(f,0))*factor;
    u[0]=(read<double>(b,1)*read<double>(f,0)-
	  read<double>(a,0)*read<double>(f,1))*factor;
    u[1]=temp;
    {Stack->push<realarray*>(up); return;}
  }
	
  static double *gamma,*delta;
  static size_t size=0;
  CheckReallocate(gamma,delta,n-2,size);
  
  gamma[0]=read<double>(c,0)*binv;
  delta[0]=read<double>(a,0)*binv;
  u[0]=read<double>(f,0)*binv;
  double beta=read<double>(c,n-1);
  double fn=read<double>(f,n-1)-beta*read<double>(u,0);
  double alpha=read<double>(b,n-1)-beta*delta[0];

  for(size_t i=1; i <= n-3; i++) {
    double alphainv=read<double>(b,i)-read<double>(a,i)*gamma[i-1];
    if(alphainv == 0.0) dividebyzero();
    alphainv=1.0/alphainv;
    beta *= -gamma[i-1];
    gamma[i]=read<double>(c,i)*alphainv;
    u[i]=(read<double>(f,i)-read<double>(a,i)*read<double>(u,i-1))*alphainv;
    fn -= beta*read<double>(u,i);
    delta[i]=-read<double>(a,i)*delta[i-1]*alphainv;
    alpha -= beta*delta[i];
  }
	
  double alphainv=read<double>(b,n-2)-read<double>(a,n-2)*gamma[n-3];
  if(alphainv == 0.0) dividebyzero();
  alphainv=1.0/alphainv;
  u[n-2]=(read<double>(f,n-2)-read<double>(a,n-2)*read<double>(u,n-3))
    *alphainv;
  beta=read<double>(a,n-1)-beta*gamma[n-3];
  double dnm1=(read<double>(c,n-2)-read<double>(a,n-2)*delta[n-3])*alphainv;
  double temp=alpha-beta*dnm1;
  if(temp == 0.0) dividebyzero();
  u[n-1]=temp=(fn-beta*read<double>(u,n-2))/temp;
  u[n-2]=read<double>(u,n-2)-dnm1*temp;
	
  for(size_t i=n-2; i >= 1; i--)
    u[i-1]=read<double>(u,i-1)-gamma[i-1]*read<double>(u,i)-delta[i-1]*temp;
  
  {Stack->push<realarray*>(up); return;}
}

// Compute the fast Fourier transform of a pair array
void pairArrayFFT(stack *Stack)
{
  int sign = vm::pop<int>(Stack,1);
  pairarray * a = vm::pop<pairarray *>(Stack);

  unsigned n=(unsigned) checkArray(a);
  array *c=new array(n);
#ifdef HAVE_LIBFFTW3
  Complex *f=FFTWComplex(n);
  fft1d Forward(n,sign,f);
  
  for(size_t i=0; i < n; i++) {
    pair z=read<pair>(a,i);
    f[i]=Complex(z.getx(),z.gety());
  }
  Forward.fft(f);
  
  for(size_t i=0; i < n; i++) {
    Complex z=f[i];
    (*c)[i]=pair(z.real(),z.imag());
  }
  FFTWdelete(f);
#else
  assert(sign); // Avoid unused variable warning message
#endif //  HAVE_LIBFFTW3
  {Stack->push<pairarray*>(c); return;}
}


// File operations
// bool ==(file *a, file *b);
void gen264(stack *Stack)
{
  file * b = vm::pop<file *>(Stack);
  file * a = vm::pop<file *>(Stack);

  {Stack->push<bool>(a == b); return;}
}

// bool !=(file *a, file *b);
void gen265(stack *Stack)
{
  file * b = vm::pop<file *>(Stack);
  file * a = vm::pop<file *>(Stack);

  {Stack->push<bool>(a != b); return;}
}

void standardOut(stack *Stack)
{

  {Stack->push<file*>(&camp::Stdout); return;}
}

void nullFile(stack *Stack)
{

  {Stack->push<file*>(&camp::nullfile); return;}
}

// file* input(string name, bool check=true, string comment=commentchar);
void gen268(stack *Stack)
{
  string comment = vm::pop<string>(Stack,commentchar);
  bool check = vm::pop<bool>(Stack,true);
  string name = vm::pop<string>(Stack);

  char c=comment == "" ? (char) 0 : comment[0];
  file *f=new ifile(name,check,c);
  f->open();
  {Stack->push<file*>(f); return;}
}

// file* output(string name, bool append=false);
void gen269(stack *Stack)
{
  bool append = vm::pop<bool>(Stack,false);
  string name = vm::pop<string>(Stack);

  file *f=new ofile(name,append);
  f->open();
  {Stack->push<file*>(f); return;}
}

// file* xinput(string name, bool check=true);
void gen270(stack *Stack)
{
  bool check = vm::pop<bool>(Stack,true);
  string name = vm::pop<string>(Stack);

#ifdef HAVE_RPC_RPC_H
  file *f=new ixfile(name,check);
  {Stack->push<file*>(f); return;}
#else  
  error("XDR support not enabled");
#endif
}

// file* xoutput(string name, bool append=false);
void gen271(stack *Stack)
{
  bool append = vm::pop<bool>(Stack,false);
  string name = vm::pop<string>(Stack);

#ifdef HAVE_RPC_RPC_H
  file *f=new oxfile(name,append);
  {Stack->push<file*>(f); return;}
#else  
  error("XDR support not enabled");
#endif
}

// bool eof(file *File);
void gen272(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);

  {Stack->push<bool>(File->eof()); return;}
}

// bool eol(file *File);
void gen273(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);

  {Stack->push<bool>(File->eol()); return;}
}

// bool error(file *File);
void gen274(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);

  {Stack->push<bool>(File->error()); return;}
}

// void clear(file *File);
void gen275(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);

  File->clear();
}

// void close(file *File);
void gen276(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);

  File->close();
}

// void precision(file *File, int digits);
void gen277(stack *Stack)
{
  int digits = vm::pop<int>(Stack);
  file * File = vm::pop<file *>(Stack);

  File->precision(digits);
}

// void flush(file *File);
void gen278(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);

   File->flush();
}

// string getc(file *File);
void gen279(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);

  char c;
  if(File->isOpen()) File->read(c);
  static char str[1];
  str[0]=c;
  {Stack->push<string>(string(str)); return;}
}

// Set file dimensions
// file* dimension(file *File, int nx);
void gen280(stack *Stack)
{
  int nx = vm::pop<int>(Stack);
  file * File = vm::pop<file *>(Stack);

  File->dimension(nx);
  {Stack->push<file*>(File); return;}
}

// file* dimension(file *File, int nx, int ny);
void gen281(stack *Stack)
{
  int ny = vm::pop<int>(Stack);
  int nx = vm::pop<int>(Stack);
  file * File = vm::pop<file *>(Stack);

  File->dimension(nx,ny);
  {Stack->push<file*>(File); return;}
}

// file* dimension(file *File, int nx, int ny, int nz);
void gen282(stack *Stack)
{
  int nz = vm::pop<int>(Stack);
  int ny = vm::pop<int>(Stack);
  int nx = vm::pop<int>(Stack);
  file * File = vm::pop<file *>(Stack);

  File->dimension(nx,ny,nz);
  {Stack->push<file*>(File); return;}
}

// Set file to read comma-separated values
// file* csv(file *File, bool b=true);
void gen283(stack *Stack)
{
  bool b = vm::pop<bool>(Stack,true);
  file * File = vm::pop<file *>(Stack);

  File->CSVMode(b);
  {Stack->push<file*>(File); return;}
}

// Set file to read arrays in line-at-a-time mode
// file* line(file *File, bool b=true);
void gen284(stack *Stack)
{
  bool b = vm::pop<bool>(Stack,true);
  file * File = vm::pop<file *>(Stack);

  File->LineMode(b);
  {Stack->push<file*>(File); return;}
}

// Set file to read/write single-precision XDR values.
// file* single(file *File, bool b=true);
void gen285(stack *Stack)
{
  bool b = vm::pop<bool>(Stack,true);
  file * File = vm::pop<file *>(Stack);

  File->SingleMode(b);
  {Stack->push<file*>(File); return;}
}

// Set file to read an array1 (1 int size followed by a 1d array)
// file* read1(file *File);
void gen286(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);

  File->dimension(-2);
  {Stack->push<file*>(File); return;}
}

// Set file to read an array2 (2 int sizes followed by a 2d array)
// file* read2(file *File);
void gen287(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);

  File->dimension(-2,-2);
  {Stack->push<file*>(File); return;}
}

// Set file to read an array3 (3 int sizes followed by a 3d array)
// file* read3(file *File);
void gen288(stack *Stack)
{
  file * File = vm::pop<file *>(Stack);

  File->dimension(-2,-2,-2);
  {Stack->push<file*>(File); return;}
}

} // namespace run

namespace trans {

void gen_base_venv(venv &ve)
{
  addFunc(ve, run::gen8, primBoolean(), "!", formal(primBoolean(), "b", false, false));
  addFunc(ve, run::gen17, primBoolean(), "empty", formal(primPicture(), "f", false, false));
  addFunc(ve, run::gen18, primPair(), "max", formal(primPicture(), "f", false, false));
  addFunc(ve, run::gen19, primPair(), "min", formal(primPicture(), "f", false, false));
  addFunc(ve, run::gen20, primVoid(), "label", formal(primPicture(), "f", false, false), formal(primString(), "s", false, false), formal(primString(), "size", false, false), formal(primReal(), "angle", false, false), formal(primPair(), "position", false, false), formal(primPair(), "align", false, false), formal(primPair(), "scale", false, false), formal(primPen(), "p", false, false));
  addFunc(ve, run::gen21, primBoolean(), "labels", formal(primPicture(), "f", false, false));
  addFunc(ve, run::gen22, primVoid(), "fill", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "p", false, false));
  addFunc(ve, run::gen23, primVoid(), "latticeshade", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "fillrule", false, false), formal(penArray2()  , "p", false, false));
  addFunc(ve, run::gen24, primVoid(), "axialshade", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "pena", false, false), formal(primPair(), "a", false, false), formal(primPen(), "penb", false, false), formal(primPair(), "b", false, false));
  addFunc(ve, run::gen25, primVoid(), "radialshade", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "pena", false, false), formal(primPair(), "a", false, false), formal(primReal(), "ra", false, false), formal(primPen(), "penb", false, false), formal(primPair(), "b", false, false), formal(primReal(), "rb", false, false));
  addFunc(ve, run::gen26, primVoid(), "gouraudshade", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "fillrule", false, false), formal(penArray()  , "p", false, false), formal(pairArray(), "z", false, false), formal(intArray(), "edges", false, false));
  addFunc(ve, run::gen27, primVoid(), "clip", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "p", false, false));
  addFunc(ve, run::gen28, primVoid(), "beginclip", formal(primPicture(), "f", false, false), formal(pathArray()  , "g", false, false), formal(primPen(), "p", false, false));
  addFunc(ve, run::gen29, primVoid(), "postscript", formal(primPicture(), "f", false, false), formal(primString() , "s", false, false));
  addFunc(ve, run::gen30, primVoid(), "tex", formal(primPicture(), "f", false, false), formal(primString() , "s", false, false));
  addFunc(ve, run::gen31, primVoid(), "texpreamble", formal(primString() , "s", false, false));
  addFunc(ve, run::gen32, primVoid(), "layer", formal(primPicture(), "f", false, false));
  addFunc(ve, run::gen33, primVoid(), "image", formal(primPicture(), "f", false, false), formal(realArray2(), "data", false, false), formal(penArray()  , "palette", false, false), formal(primPair(), "initial", false, false), formal(primPair(), "final", false, false));
  addFunc(ve, run::gen34, primVoid(), "shipout", formal(primString() , "prefix", true, false), formal(primPicture(), "f", false, false), formal(primPicture(), "preamble", true, false), formal(primString() , "format", true, false), formal(primBoolean(), "wait", true, false), formal(primBoolean(), "quiet", true, false), formal(transformArray(), "guitransform", false, false), formal(boolArray(), "guidelete", false, false));
  addFunc(ve, run::gen36, primBoolean(), "==", formal(primPen(), "a", false, false), formal(primPen(), "b", false, false));
  addFunc(ve, run::gen37, primBoolean(), "!=", formal(primPen(), "a", false, false), formal(primPen(), "b", false, false));
  addFunc(ve, run::gen38, primPen(), "+", formal(primPen(), "a", false, false), formal(primPen(), "b", false, false));
  addFunc(ve, run::gen39, primPen(), "*", formal(primReal(), "a", false, false), formal(primPen(), "b", false, false));
  addFunc(ve, run::gen40, primPen(), "*", formal(primPen(), "a", false, false), formal(primReal(), "b", false, false));
  addFunc(ve, run::gen41, primPair(), "max", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen42, primPair(), "min", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen43, primVoid(), "resetdefaultpen");
  addFunc(ve, run::gen44, primVoid(), "defaultpen", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen45, primPen(), "defaultpen");
  addFunc(ve, run::gen46, primPen(), "invisible");
  addFunc(ve, run::gen47, primPen(), "gray", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen48, primPen(), "rgb", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen49, primPen(), "rgb", formal(primReal(), "r", false, false), formal(primReal(), "g", false, false), formal(primReal(), "b", false, false));
  addFunc(ve, run::gen50, primPen(), "cmyk", formal(primReal(), "c", false, false), formal(primReal(), "m", false, false), formal(primReal(), "y", false, false), formal(primReal(), "k", false, false));
  addFunc(ve, run::gen51, primPen(), "gray", formal(primReal(), "gray", false, false));
  addFunc(ve, run::gen52, realArray(), "colors", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen53, primPen(), "pattern", formal(primString(), "s", false, false));
  addFunc(ve, run::gen54, primString() , "pattern", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen55, primPen(), "fillrule", formal(primInt(), "n", false, false));
  addFunc(ve, run::gen56, primInt(), "fillrule", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen57, primPen(), "linetype", formal(primString(), "s", false, false), formal(primBoolean(), "scale", false, false));
  addFunc(ve, run::gen58, primString() , "linetype", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen59, primPen(), "linecap", formal(primInt(), "n", false, false));
  addFunc(ve, run::gen60, primInt(), "linecap", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen61, primPen(), "linejoin", formal(primInt(), "n", false, false));
  addFunc(ve, run::gen62, primInt(), "linejoin", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen63, primPen(), "linewidth", formal(primReal(), "x", false, false));
  addFunc(ve, run::gen64, primReal(), "linewidth", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen65, primPen(), "fontcommand", formal(primString(), "s", false, false));
  addFunc(ve, run::gen66, primString() , "font", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen67, primPen(), "fontsize", formal(primReal(), "size", false, false), formal(primReal(), "skip", false, false));
  addFunc(ve, run::gen68, primReal(), "fontsize", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen69, primReal(), "lineskip", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen70, primPen(), "overwrite", formal(primInt(), "n", false, false));
  addFunc(ve, run::gen71, primInt(), "overwrite", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen72, primPen(), "basealign", formal(primInt(), "n", false, false));
  addFunc(ve, run::gen73, primInt(), "basealign", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen74, primPath(), "nib", formal(primPen(), "p", false, false));
  addFunc(ve, run::gen75, primPen(), "makepen", formal(primPath(), "p", false, false));
  addFunc(ve, run::gen76, primVoid(), "_draw", formal(primPicture(), "f", false, false), formal(primPath(), "g", false, false), formal(primPen(), "p", false, false));
  addFunc(ve, run::gen77, primVoid(), "endclip", formal(primPicture(), "f", false, false));
  addFunc(ve, run::gen78, primVoid(), "gsave", formal(primPicture(), "f", false, false));
  addFunc(ve, run::gen79, primVoid(), "grestore", formal(primPicture(), "f", false, false));
  addFunc(ve, run::gen80, primVoid(), "begingroup", formal(primPicture(), "f", false, false));
  addFunc(ve, run::gen81, primVoid(), "endgroup", formal(primPicture(), "f", false, false));
  addFunc(ve, run::gen82, primVoid(), "add", formal(primPicture(), "dest", false, false), formal(primPicture(), "src", false, false));
  addFunc(ve, run::gen83, primVoid(), "prepend", formal(primPicture(), "dest", false, false), formal(primPicture(), "src", false, false));
  addFunc(ve, run::gen84, primString() , "fileprefix");
  addFunc(ve, run::gen85, primBoolean(), "interact");
  addFunc(ve, run::gen86, primVoid(), "uptodate", formal(primBoolean(), "b", false, false));
  addFunc(ve, run::gen87, primBoolean(), "uptodate");
  addFunc(ve, run::gen88, primInt(), "system", formal(primString(), "str", false, false));
  addFunc(ve, run::gen89, primVoid(), "abort", formal(primString(), "msg", false, false));
  addFunc(ve, run::gen90, primVoid(), "_eval", formal(primString(), "s", false, false), formal(primBoolean(), "embedded", false, false));
  addFunc(ve, run::gen91, primVoid(), "_eval", formal(primCode(), "s", false, false), formal(primBoolean(), "embedded", false, false));
  addFunc(ve, run::gen92, primVoid(), "gui", formal(primReal(), "x", true, false));
  addFunc(ve, run::gen93, primBoolean(), "deconstruct");
  addFunc(ve, run::gen94, primVoid(), "readGUI");
  addFunc(ve, run::gen96, primString() , "cd", formal(primString(), "d", false, false));
  addFunc(ve, run::gen97, primVoid(), "scroll", formal(primInt(), "n", false, false));
  addFunc(ve, run::gen99, primPair(), "point", formal(primPath(), "p", false, false), formal(primInt(), "n", false, false));
  addFunc(ve, run::gen100, primPair(), "point", formal(primPath(), "p", false, false), formal(primReal(), "t", false, false));
  addFunc(ve, run::gen101, primPair(), "precontrol", formal(primPath(), "p", false, false), formal(primInt(), "n", false, false));
  addFunc(ve, run::gen102, primPair(), "precontrol", formal(primPath(), "p", false, false), formal(primReal(), "t", false, false));
  addFunc(ve, run::gen103, primPair(), "postcontrol", formal(primPath(), "p", false, false), formal(primInt(), "n", false, false));
  addFunc(ve, run::gen104, primPair(), "postcontrol", formal(primPath(), "p", false, false), formal(primReal(), "t", false, false));
  addFunc(ve, run::gen105, primPair(), "dir", formal(primPath(), "p", false, false), formal(primInt(), "n", false, false));
  addFunc(ve, run::gen106, primPair(), "dir", formal(primPath(), "p", false, false), formal(primReal(), "t", false, false));
  addFunc(ve, run::gen107, primPath(), "reverse", formal(primPath(), "p", false, false));
  addFunc(ve, run::gen108, primPath(), "subpath", formal(primPath(), "p", false, false), formal(primInt(), "b", false, false), formal(primInt(), "e", false, false));
  addFunc(ve, run::gen109, primPath(), "subpath", formal(primPath(), "p", false, false), formal(primReal(), "b", false, false), formal(primReal(), "e", false, false));
  addFunc(ve, run::gen110, primInt(), "length", formal(primPath(), "p", false, false));
  addFunc(ve, run::gen111, primBoolean(), "cyclic", formal(primPath(), "p", false, false));
  addFunc(ve, run::gen112, primBoolean(), "straight", formal(primPath(), "p", false, false), formal(primInt(), "i", false, false));
  addFunc(ve, run::gen113, primReal(), "arclength", formal(primPath(), "p", false, false));
  addFunc(ve, run::gen114, primReal(), "arctime", formal(primPath(), "p", false, false), formal(primReal(), "dval", false, false));
  addFunc(ve, run::gen115, primReal(), "dirtime", formal(primPath(), "p", false, false), formal(primPair(), "z", false, false));
  addFunc(ve, run::gen116, primPair(), "intersect", formal(primPath(), "x", false, false), formal(primPath(), "y", false, false), formal(primReal(), "fuzz", true, false));
  addFunc(ve, run::gen117, primInt(), "size", formal(primPath(), "p", false, false));
  addFunc(ve, run::gen118, primPath(), "&", formal(primPath(), "p", false, false), formal(primPath(), "q", false, false));
  addFunc(ve, run::gen119, primPair(), "min", formal(primPath(), "p", false, false));
  addFunc(ve, run::gen120, primPair(), "max", formal(primPath(), "p", false, false));
  addFunc(ve, run::gen121, primReal(), "relativedistance", formal(primReal(), "theta", false, false), formal(primReal(), "phi", false, false), formal(primReal(), "t", false, false), formal(primBoolean(), "atleast", false, false));
  addFunc(ve, run::gen122, primBoolean(), "inside", formal(pathArray()  , "g", false, false), formal(primPair(), "z", false, false), formal(primPen(), "p", false, false));
  addFunc(ve, run::gen126, primGuide(), "operator cycle");
  addFunc(ve, run::gen127, primGuide(), "operator spec", formal(primPair(), "z", false, false), formal(primInt(), "p", false, false));
  addFunc(ve, run::gen128, primGuide(), "operator curl", formal(primReal(), "gamma", false, false), formal(primInt(), "p", false, false));
  addFunc(ve, run::gen129, primGuide(), "operator tension", formal(primReal(), "tout", false, false), formal(primReal(), "tin", false, false), formal(primBoolean(), "atleast", false, false));
  addFunc(ve, run::gen130, primGuide(), "operator controls", formal(primPair(), "zout", false, false), formal(primPair(), "zin", false, false));
  addFunc(ve, run::gen132, primInt(), "length", formal(primString(), "s", false, false));
  addFunc(ve, run::gen133, primInt(), "find", formal(primString(), "s", false, false), formal(primString() , "t", false, false), formal(primInt(), "pos", true, false));
  addFunc(ve, run::gen134, primInt(), "rfind", formal(primString(), "s", false, false), formal(primString() , "t", false, false), formal(primInt(), "pos", true, false));
  addFunc(ve, run::gen135, primString() , "reverse", formal(primString() , "s", false, false));
  addFunc(ve, run::gen136, primString() , "insert", formal(primString() , "s", false, false), formal(primInt(), "pos", false, false), formal(primString() , "t", false, false));
  addFunc(ve, run::gen137, primString() , "substr", formal(primString(), "s", false, false), formal(primInt(), "pos", false, false), formal(primInt(), "n", true, false));
  addFunc(ve, run::gen138, primString() , "erase", formal(primString() , "s", false, false), formal(primInt(), "pos", false, false), formal(primInt(), "n", false, false));
  addFunc(ve, run::gen139, primString() , "replace", formal(primString(), "s", false, false), formal(stringArray2(), "translate", false, false));
  addFunc(ve, run::gen140, primString() , "format", formal(primString(), "format", false, false), formal(primInt(), "x", false, false));
  addFunc(ve, run::gen141, primString() , "format", formal(primString(), "format", false, false), formal(primReal(), "x", false, false));
  addFunc(ve, run::gen142, primString() , "time", formal(primString(), "format", false, false));
  addFunc(ve, run::gen143, primReal(), "^", formal(primReal(), "x", false, false), formal(primInt(), "y", false, false));
  addFunc(ve, run::gen144, primInt(), "quotient", formal(primInt(), "x", false, false), formal(primInt(), "y", false, false));
  addFunc(ve, run::gen145, primInt(), "abs", formal(primInt(), "x", false, false));
  addFunc(ve, run::gen146, primInt(), "sgn", formal(primReal(), "x", false, false));
  addFunc(ve, run::gen147, primInt(), "rand");
  addFunc(ve, run::gen148, primVoid(), "srand", formal(primInt(), "seed", false, false));
  addFunc(ve, run::gen149, primInt(), "ceil", formal(primReal(), "x", false, false));
  addFunc(ve, run::gen150, primInt(), "floor", formal(primReal(), "x", false, false));
  addFunc(ve, run::gen151, primInt(), "round", formal(primReal(), "x", false, false));
  addFunc(ve, run::gen152, primInt(), "Ceil", formal(primReal(), "x", false, false));
  addFunc(ve, run::gen153, primInt(), "Floor", formal(primReal(), "x", false, false));
  addFunc(ve, run::gen154, primInt(), "Round", formal(primReal(), "x", false, false));
  addFunc(ve, run::gen155, primReal(), "fmod", formal(primReal(), "x", false, false), formal(primReal(), "y", false, false));
  addFunc(ve, run::gen156, primReal(), "atan2", formal(primReal(), "y", false, false), formal(primReal(), "x", false, false));
  addFunc(ve, run::gen157, primReal(), "hypot", formal(primReal(), "x", false, false), formal(primReal(), "y", false, false));
  addFunc(ve, run::gen158, primReal(), "remainder", formal(primReal(), "x", false, false), formal(primReal(), "y", false, false));
  addFunc(ve, run::gen159, primReal(), "J", formal(primInt(), "n", false, false), formal(primReal(), "x", false, false));
  addFunc(ve, run::gen160, primReal(), "Y", formal(primInt(), "n", false, false), formal(primReal(), "x", false, false));
  addFunc(ve, run::gen161, primReal(), "erf", formal(primReal(), "x", false, false));
  addFunc(ve, run::gen162, primReal(), "erfc", formal(primReal(), "x", false, false));
  addFunc(ve, run::gen163, primReal(), "gamma", formal(primReal(), "x", false, false));
  addFunc(ve, run::gen164, realArray(), "quadraticroots", formal(primReal(), "a", false, false), formal(primReal(), "b", false, false), formal(primReal(), "c", false, false));
  addFunc(ve, run::gen165, realArray(), "cubicroots", formal(primReal(), "a", false, false), formal(primReal(), "b", false, false), formal(primReal(), "c", false, false), formal(primReal(), "d", false, false));
  addFunc(ve, run::gen166, primBoolean(), "==", formal(primTransform(), "a", false, false), formal(primTransform(), "b", false, false));
  addFunc(ve, run::gen167, primBoolean(), "!=", formal(primTransform(), "a", false, false), formal(primTransform(), "b", false, false));
  addFunc(ve, run::gen168, primTransform(), "*", formal(primTransform(), "a", false, false), formal(primTransform(), "b", false, false));
  addFunc(ve, run::gen169, primPair(), "*", formal(primTransform(), "t", false, false), formal(primPair(), "z", false, false));
  addFunc(ve, run::gen170, primPath(), "*", formal(primTransform(), "t", false, false), formal(primPath(), "g", false, false));
  addFunc(ve, run::gen171, primPen(), "*", formal(primTransform(), "t", false, false), formal(primPen(), "p", false, false));
  addFunc(ve, run::gen172, primPicture(), "*", formal(primTransform(), "t", false, false), formal(primPicture(), "f", false, false));
  addFunc(ve, run::gen173, primTransform(), "^", formal(primTransform(), "t", false, false), formal(primInt(), "n", false, false));
  addFunc(ve, run::transformIdentity, primTransform(), "identity");
  addFunc(ve, run::gen182, primTransform(), "inverse", formal(primTransform(), "t", false, false));
  addFunc(ve, run::gen183, primTransform(), "shift", formal(primPair(), "z", false, false));
  addFunc(ve, run::gen184, primTransform(), "xscale", formal(primReal(), "x", false, false));
  addFunc(ve, run::gen185, primTransform(), "yscale", formal(primReal(), "y", false, false));
  addFunc(ve, run::gen186, primTransform(), "scale", formal(primReal(), "x", false, false));
  addFunc(ve, run::gen187, primTransform(), "slant", formal(primReal(), "s", false, false));
  addFunc(ve, run::gen188, primTransform(), "rotate", formal(primReal(), "angle", false, false), formal(primPair(), "z", true, false));
  addFunc(ve, run::gen189, primTransform(), "reflect", formal(primPair(), "a", false, false), formal(primPair(), "b", false, false));
  addFunc(ve, run::gen195, primReal(), "length", formal(primPair(), "z", false, false));
  addFunc(ve, run::gen196, primReal(), "abs", formal(primPair(), "z", false, false));
  addFunc(ve, run::gen197, primReal(), "angle", formal(primPair(), "z", false, false));
  addFunc(ve, run::gen198, primReal(), "degrees", formal(primPair(), "z", false, false));
  addFunc(ve, run::gen199, primPair(), "unit", formal(primPair(), "z", false, false));
  addFunc(ve, run::gen200, primPair(), "dir", formal(primReal(), "theta", false, false));
  addFunc(ve, run::gen201, primPair(), "expi", formal(primReal(), "theta", false, false));
  addFunc(ve, run::gen202, primPair(), "conj", formal(primPair(), "z", false, false));
  addFunc(ve, run::gen203, primReal(), "dot", formal(primPair(), "u", false, true), formal(primPair(), "v", false, true));
  addFunc(ve, run::gen209, primTriple(), "*", formal(primReal(), "x", false, false), formal(primTriple(), "v", false, false));
  addFunc(ve, run::gen210, primTriple(), "*", formal(primTriple(), "v", false, false), formal(primReal(), "x", false, false));
  addFunc(ve, run::gen211, primTriple(), "/", formal(primTriple(), "v", false, false), formal(primReal(), "x", false, false));
  addFunc(ve, run::gen212, primReal(), "length", formal(primTriple(), "v", false, false));
  addFunc(ve, run::gen213, primReal(), "abs", formal(primTriple(), "v", false, false));
  addFunc(ve, run::gen214, primReal(), "polar", formal(primTriple(), "v", false, false));
  addFunc(ve, run::gen215, primReal(), "azimuth", formal(primTriple(), "v", false, false));
  addFunc(ve, run::gen216, primReal(), "colatitude", formal(primTriple(), "v", false, false));
  addFunc(ve, run::gen217, primReal(), "latitude", formal(primTriple(), "v", false, false));
  addFunc(ve, run::gen218, primReal(), "longitude", formal(primTriple(), "v", false, false));
  addFunc(ve, run::gen219, primTriple(), "unit", formal(primTriple(), "v", false, false));
  addFunc(ve, run::gen220, primReal(), "dot", formal(primTriple(), "u", false, false), formal(primTriple(), "v", false, false));
  addFunc(ve, run::gen221, primTriple(), "cross", formal(primTriple(), "u", false, false), formal(primTriple(), "v", false, false));
  addFunc(ve, run::gen222, primTriple(), "expi", formal(primReal(), "theta", false, false), formal(primReal(), "phi", false, false));
  addFunc(ve, run::gen223, primTriple(), "dir", formal(primReal(), "theta", false, false), formal(primReal(), "phi", false, false));
  addFunc(ve, run::gen224, primReal(), "cubiclength", formal(primTriple(), "z0", false, false), formal(primTriple(), "z0p", false, false), formal(primTriple(), "z1m", false, false), formal(primTriple(), "z1", false, false), formal(primReal(), "goal", false, false));
  addFunc(ve, run::gen225, primPair(), "intersect", formal(tripleArray(), "pre1", false, false), formal(tripleArray(), "point1", false, false), formal(tripleArray(), "post1", false, false), formal(tripleArray(), "pre2", false, false), formal(tripleArray(), "point2", false, false), formal(tripleArray(), "post2", false, false), formal(primReal(), "fuzz", false, false));
  addFunc(ve, run::gen226, primString() , "VERSION");
  addFunc(ve, run::gen227, primVoid(), "quiet", formal(primBoolean(), "v", false, false));
  addFunc(ve, run::gen228, primVoid(), "atexit", formal(voidFunction(), "f", false, false));
  addFunc(ve, run::gen229, voidFunction(), "atexit");
  addFunc(ve, run::gen230, primInt(), "merge", formal(stringArray(), "files", false, false), formal(primString(), "args", false, false), formal(primString(), "format", false, false), formal(primBoolean(), "keep", false, false));
  addFunc(ve, run::gen251, intArray(), "sequence", formal(primInt(), "n", false, false));
  addFunc(ve, run::gen253, primBoolean(), "all", formal(boolArray(), "a", false, false));
  addFunc(ve, run::gen254, boolArray(), "!", formal(boolArray(), "a", false, false));
  addFunc(ve, run::gen255, primInt(), "sum", formal(boolArray(), "a", false, false));
  addFunc(ve, run::gen260, primInt(), "find", formal(boolArray(), "a", false, false), formal(primInt(), "n", true, false));
  addFunc(ve, run::gen262, realArray(), "tridiagonal", formal(realArray(), "a", false, false), formal(realArray(), "b", false, false), formal(realArray(), "c", false, false), formal(realArray(), "f", false, false));
  addFunc(ve, run::gen264, primBoolean(), "==", formal(primFile(), "a", false, false), formal(primFile(), "b", false, false));
  addFunc(ve, run::gen265, primBoolean(), "!=", formal(primFile(), "a", false, false), formal(primFile(), "b", false, false));
  addFunc(ve, run::gen268, primFile(), "input", formal(primString() , "name", false, false), formal(primBoolean(), "check", true, false), formal(primString() , "comment", true, false));
  addFunc(ve, run::gen269, primFile(), "output", formal(primString() , "name", false, false), formal(primBoolean(), "append", true, false));
  addFunc(ve, run::gen270, primFile(), "xinput", formal(primString() , "name", false, false), formal(primBoolean(), "check", true, false));
  addFunc(ve, run::gen271, primFile(), "xoutput", formal(primString() , "name", false, false), formal(primBoolean(), "append", true, false));
  addFunc(ve, run::gen272, primBoolean(), "eof", formal(primFile(), "file", false, false));
  addFunc(ve, run::gen273, primBoolean(), "eol", formal(primFile(), "file", false, false));
  addFunc(ve, run::gen274, primBoolean(), "error", formal(primFile(), "file", false, false));
  addFunc(ve, run::gen275, primVoid(), "clear", formal(primFile(), "file", false, false));
  addFunc(ve, run::gen276, primVoid(), "close", formal(primFile(), "file", false, false));
  addFunc(ve, run::gen277, primVoid(), "precision", formal(primFile(), "file", false, false), formal(primInt(), "digits", false, false));
  addFunc(ve, run::gen278, primVoid(), "flush", formal(primFile(), "file", false, false));
  addFunc(ve, run::gen279, primString() , "getc", formal(primFile(), "file", false, false));
  addFunc(ve, run::gen280, primFile(), "dimension", formal(primFile(), "file", false, false), formal(primInt(), "nx", false, false));
  addFunc(ve, run::gen281, primFile(), "dimension", formal(primFile(), "file", false, false), formal(primInt(), "nx", false, false), formal(primInt(), "ny", false, false));
  addFunc(ve, run::gen282, primFile(), "dimension", formal(primFile(), "file", false, false), formal(primInt(), "nx", false, false), formal(primInt(), "ny", false, false), formal(primInt(), "nz", false, false));
  addFunc(ve, run::gen283, primFile(), "csv", formal(primFile(), "file", false, false), formal(primBoolean(), "b", true, false));
  addFunc(ve, run::gen284, primFile(), "line", formal(primFile(), "file", false, false), formal(primBoolean(), "b", true, false));
  addFunc(ve, run::gen285, primFile(), "single", formal(primFile(), "file", false, false), formal(primBoolean(), "b", true, false));
  addFunc(ve, run::gen286, primFile(), "read1", formal(primFile(), "file", false, false));
  addFunc(ve, run::gen287, primFile(), "read2", formal(primFile(), "file", false, false));
  addFunc(ve, run::gen288, primFile(), "read3", formal(primFile(), "file", false, false));
}

} // namespace trans
